#include <iostream>
#include <fstream>
#include <algorithm>
#include <cassert>
#include <memory.h>
using namespace std;

const char iname[] = "gaz.in";
const char oname[] = "gaz.out";

const int MAX_N = 2005;
const int INF   = 0x3f3f3f3f;

typedef long long i64;

i64 bst[MAX_N][MAX_N];

int main(void) {
    FILE *fi = fopen(iname, "r");
    FILE *fo = fopen(oname, "w");
    int L, P, D, C, N, SG = 0;
    i64 G[MAX_N], S[MAX_N] = {0};

    assert(fscanf(fi, "%d %d %d %d", &L, &P, &D, &C) == 4);
    assert(fscanf(fi, "%d", &N) == 1);
    for (int i = 0; i < N; ++ i) {
        assert(fscanf(fi, "%d", &G[i]) == 1);
        SG += G[i];
        S[i] = (i > 0 ? S[i - 1] : 0) + G[i];
    }

    for (int i = 0; i < N; ++ i)
        bst[i][i] = P;
    for (int d = 1; d < N; ++ d) for (int i = 0; i < N - d; ++ i) {
        int j = i + d;

        int sum = S[j] - (i > 0 ? S[i - 1] : 0);
        bst[i][j] = P;
        for (int k = i; k <= j; ++ k) {
            sum -= G[k];
            bst[i][j] += max(0, sum - L) * C;
        }

        for (int k = i; k < j; ++ k)
            bst[i][j] = min(bst[i][j], bst[i][k] + bst[k + 1][j]);
    }

    fprintf(fopen(oname, "w"), "%lld\n", bst[0][N - 1] + SG * D);
    // printf("%lld\n", bst[0][N - 1] + SG * D);

    fclose(fi), fclose(fo);
    return 0;
}
