#include <stdio.h>
#include <time.h>

#define N2_SOL 0
#define MINV_SOL 0
#define N_MLE_SOL 0
#define N_K_SPLIT_SOL 0
#define DIVIDE_ET_IMPERA_SOL 1
#define DIVIDE_ET_IMPERA_OPT_SOL 0

#define max(a,b) ((a) >= (b) ? (a) : (b))
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define A(Aprev, Bprev) (((Aprev + P - 1) ^ (Bprev + 1)) % P)
#define B(Aprev, Bprev) (((Aprev + P - 1) | (Bprev + 1)) % P)
#define val(Acurr, Bcurr, pos) (max(1,((((pos) % (P)) ^ (((Acurr + 1) & (Bcurr + 1)) % (P))) % (P))))
#define aggf(a, b) (((long long)(a) * (long long)(b)) % Q)
//#define aggf(a, b) (max(a,b))

int N, P, Q, A1, B1;
int i, j, Ap, Bp, Ac, Bc, Ap2, Bp2, x, rez;

void readInputData(void)
{
	freopen("xp.in", "r", stdin);
	scanf("%d %d %d %d %d", &N, &A1, &B1, &P, &Q);
}

void n2_sol(void)
{
	int crez;

	rez = 0;

	for (i = 1; i <= N; i++)
	{
		crez = 1;
		if (i > 1)
			crez = val(A1, B1, 1);

		Ap = A1; Bp = B1;

		for (j = 2; j <= N; j++)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			
			if (j != i)
				crez = aggf(crez, val(Ac, Bc, j));

			Ap = Ac; Bp = Bc;
		}

		rez ^= crez;
	}

	fprintf(stderr, "N^2 solution: rez=%d\n", rez);
}

int gcd(int a, int b)
{
	if (b == 0) return a;
	else return gcd(b, a % b);
}

long long extendedEuclid(long long a, long long b, long long *x, long long *y)
{
	long long x1, y1, d;

	if (b == 0)
	{
		*x = 1;
		*y = 0;
		return a;
	}
	else
	{
		d = extendedEuclid(b, a % b, &x1, &y1);
		*x = y1;
		*y = x1 - (a/b)*y1;
		return d;
	}
}

long long modularInverse(long long a)
{
	long long x, y, d;

	d = extendedEuclid((long long) Q, a, &x, &y);

	while (y<0)
		y = y + Q;

	return (y % Q);
}

void minv_sol(void)
{
	int crez, x, y, z, cnt;
	int minv, d;

	rez = 0;

	crez = val(A1, B1, 1);
	Ap = A1; Bp = B1;

	for (i = 2; i <= N; i++)
	{
		Ac = A(Ap, Bp);
		Bc = B(Ap, Bp);
		crez = aggf(crez, val(Ac, Bc, i));
		Ap = Ac; Bp = Bc;
	}

	Ac = A1; Bc = B1;
	for (i = 1; i <= N; i++)
	{
		x = val(Ac, Bc, i);

		d = gcd(x, Q);
		minv = (int) modularInverse((long long) x);
		/*
		cnt = 0;
		for (y = 0; y < Q; y++)
			if (aggf(x, y) == crez)
			{
				cnt++;
				if (cnt == 1) z = y;
			}

		if (cnt > 1)
			fprintf(stderr, "multiple solutions (%d) at position %d\n", cnt, i);
		*/

		if (d == 1)
			z = ((long long) minv * (long long) (crez / d)) % Q;
		else
		{
			for (z = y = 0; y < Q; y++)
				if (z == crez)
					break;
				else
					z = (z + d) % Q;

			if (y == Q)
				fprintf(stderr, "i=%d: caz nasol\n");

			z = ((long long) minv * (long long) (y)) % Q;
		}

		rez ^= z;

		Ap = Ac; Bp = Bc;
		Ac = A(Ap, Bp);
		Bc = B(Ap, Bp);
	}

	fprintf(stderr, "minv solution: rez=%d\n", rez);
}

void n_mle_sol(void)
{
	int *SP;
	int crez, num_zero = 0;

	SP = new int[N + 2];
	SP[1] = val(A1, B1, 1);

	Ap = A1; Bp = B1;
	for (i = 2; i <= N; i++)
	{
		Ac = A(Ap, Bp);
		Bc = B(Ap, Bp);
		SP[i] = val(Ac, Bc, i);
		Ap = Ac; Bp = Bc;
	}

	SP[N + 1] = 1;
	for (i = N - 1; i >= 1; i--)
		SP[i] = aggf(SP[i], SP[i + 1]);

	rez = SP[2];

	if (rez == 0)
		num_zero++;

	crez = val(A1, B1, 1);
	Ap = A1; Bp = B1;
	
	//fprintf(stderr, "N=%d\n", N);

	for (i = 2; i <= N; i++)
	{
		if (N - i <= 100)
			fprintf(stderr, "i=%d, A=%d, B=%d, val=%d\n", i - 1, Ap, Bp, val(Ap, Bp, (i - 1)));

		rez ^= aggf(crez, SP[i + 1]);

		if (aggf(crez, SP[i + 1]) == 0)
			num_zero++;

		Ac = A(Ap, Bp);
		Bc = B(Ap, Bp);
		crez = aggf(crez, val(Ac, Bc, i));
		Ap = Ac; Bp = Bc;
	}

	//fprintf(stderr, "i=%d, A=%d, B=%d, val=%d\n", i - 1, Ap, Bp, val(Ap, Bp, (i - 1)));

	fprintf(stderr, "N MLE solution: rez=%d (N=%d, num_zero_sol=%d)\n", rez, N, num_zero);
}

#define K 3163

void n_k_split_sol(void)
{
	int *AP, *BP, *SP, *valAux;
	int AC, BC, ACaux, BCaux, crez, p, num_zero = 0, cnt = 0;

	AP = new int[(N / K) + 2];
	BP = new int[(N / K) + 2];

	Ap = A1; Bp = B1;
	for (i = 2; i <= N; i++)
	{
		Ac = A(Ap, Bp);
		Bc = B(Ap, Bp);

		if (i % K == 0)
		{
			cnt++;
			AP[cnt] = Ac;
			BP[cnt] = Bc;
		}

		Ap = Ac; Bp = Bc;
	}

	SP = AP;

	if (cnt >= 1)
	{
		Ap = AP[cnt]; Bp = BP[cnt];
		crez = 1;
		for (i = cnt * K + 1; i <= N; i++)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			crez = aggf(crez, val(Ac, Bc, i));
			Ap = Ac; Bp = Bc;
		}

		SP[cnt] = aggf(val(AP[cnt], BP[cnt], (cnt * K)), crez);
	
		for (j = cnt - 1; j >= 1; j--)
		{
			Ap = AP[j]; Bp = BP[j];
			crez = 1;
			for (i = j * K + 1; i < (j + 1) * K; i++)
			{
				Ac = A(Ap, Bp);
				Bc = B(Ap, Bp);
				crez = aggf(crez, val(Ac, Bc, i));
				Ap = Ac; Bp = Bc;
			}

			SP[j] = aggf(aggf(val(AP[j], BP[j], (j * K)), crez), SP[j + 1]);
		}
	}

	delete BP;

	valAux = new int[K + 2];
	valAux[1] = val(A1, B1, 1);
	Ap = A1; Bp = B1;

	if (N >= K - 1)
	{
		for (i = 2; i < K; i++)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			valAux[i] = val(Ac, Bc, i);
			Ap = Ac; Bp = Bc;
		}

		valAux[K] = SP[1];
		for (i = K - 1; i >= 1; i--)
			valAux[i] = aggf(valAux[i], valAux[i + 1]);
	}
	else
	{
		for (i = 2; i <= N; i++)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			valAux[i] = val(Ac, Bc, i);
			Ap = Ac; Bp = Bc;
		}

		valAux[N + 1] = 1;
		for (i = N - 1; i >= 1; i--)
			valAux[i] = aggf(valAux[i], valAux[i + 1]);
	}

	rez = 0;
	AC = A1; BC = B1;
	crez = 1; j = 1;
	for (i = 1; i <= N; i++)
	{
		if (i % K == 0)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			Ap = Ac; Bp = Bc;

			if (i + K <= N)
			{
				for (p = 1; p < K; p++)
				{
					Ac = A(Ap, Bp);
					Bc = B(Ap, Bp);
					valAux[p] = val(Ac, Bc, (i + p));
					Ap = Ac; Bp = Bc;
				}

				j++;
				valAux[K] = SP[j];
				for (p = K - 1; p >= 1; p--)
					valAux[p] = aggf(valAux[p], valAux[p + 1]);
			}
			else
			{
				for (p = i + 1; p <= N; p++)
				{
					Ac = A(Ap, Bp);
					Bc = B(Ap, Bp);
					valAux[p - i] = val(Ac, Bc, p);
					Ap = Ac; Bp = Bc;
				}

				valAux[p - i] = 1;
				for (p = p - i - 1; p >= 1; p--)
					valAux[p] = aggf(valAux[p], valAux[p + 1]);
			}
		}

		rez ^= aggf(crez, valAux[(i % K) + 1]);

		if (aggf(crez, valAux[(i % K) + 1]) == 0)
			num_zero++;

		crez = aggf(crez, val(AC, BC, i));
		ACaux = AC; BCaux = BC;
		AC = A(ACaux, BCaux);
		BC = B(ACaux, BCaux);
	}

	fprintf(stderr, "N K-split solution: rez=%d (N=%d, num_zero=%d)\n", rez, N, num_zero);
}

int totalOp;

void dei(int li, int ls, int Ali, int Bli, int outVal)
{
	int mid, Ap, Bp;

	if (li == ls)
		rez ^= outVal;
	else
	{
		mid = (li + ls) >> 1;
		
		x = val(Ali, Bli, li);
		Ap = Ali; Bp = Bli;
		for (i = li + 1; i <= mid; i++)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			x = aggf(x, val(Ac, Bc, i));
			Ap = Ac; Bp = Bc;
			totalOp++;
		}

		dei(mid + 1, ls, A(Ap, Bp), B(Ap, Bp), aggf(outVal, x));
		
		x = 1;
		for (i = mid + 1; i <= ls; i++)
		{
			Ac = A(Ap, Bp);
			Bc = B(Ap, Bp);
			x = aggf(x, val(Ac, Bc, i));
			Ap = Ac; Bp = Bc;
			totalOp++;
		}

		dei(li, mid, Ali, Bli, aggf(outVal, x));
	}
}

void divide_et_impera_sol(void)
{
	rez = 0;
	totalOp = 0;
	dei(1, N, A1, B1, 1);
	fprintf(stderr, "Divide et Impera solution: rez=%d (totalOp=%d)\n", rez, totalOp);
}

#define LMAX 30

char c[LMAX];
int AleftR[LMAX], BleftR[LMAX], aggLeft[LMAX], aggRight[LMAX], lim[LMAX];
int lev, mid2, cnt;

void dei_opt(int li, int ls, int Ali, int Bli, int outVal)
{
	int mid, Ap, Bp, x, y;

	if (li == ls)
		rez ^= outVal;
	else
	if (li > N)
		return;
	else
	{
		mid = (li + ls) >> 1;

		if (mid > N)
		{
			dei_opt(li, mid, Ali, Bli, outVal);
			return;
		}

		if (!c[lev])
		{
			cnt = 0;
			mid2 = mid;
			while (li < mid2)
			{
				mid2 = (li + mid2) >> 1;
				cnt++;
				lim[cnt] = mid2;
			}

			x = y = val(Ali, Bli, li);
			Ap = Ali; Bp = Bli;

			if (lim[cnt] == li)
			{
				AleftR[lev + cnt] = Ap;
				BleftR[lev + cnt] = Bp;
				aggLeft[lev + cnt] = x;
				c[lev + cnt] = 1;
				cnt--;
				y = 1;
			}

			for (i = li + 1; i <= mid; i++)
			{
				Ac = A(Ap, Bp);
				Bc = B(Ap, Bp);
				x = aggf(x, val(Ac, Bc, i));
				y = aggf(y, val(Ac, Bc, i));
				Ap = Ac; Bp = Bc;

				if (cnt > 0 && i == lim[cnt])
				{
					AleftR[lev + cnt] = Ac;
					BleftR[lev + cnt] = Bc;
					aggLeft[lev + cnt] = x;
					c[lev + cnt] = 1;
					aggRight[lev + cnt + 1] = y;
					y = 1;
					cnt--;
				}

				totalOp++;
			}

			aggRight[lev + 1] = y;

			y = 1;
			Ap2 = Ap; Bp2 = Bp;
			
			cnt = min(N, ls);
			for (i = mid + 1; i <= cnt; i++)
			{
				Ac = A(Ap2, Bp2);
				Bc = B(Ap2, Bp2);
				y = aggf(y, val(Ac, Bc, i));
				Ap2 = Ac; Bp2 = Bc;
				totalOp++;
			}
		}
		else
		{
			x = aggLeft[lev];
			y = aggRight[lev];
			Ap = AleftR[lev];
			Bp = BleftR[lev];
		}

		lev++;
		dei_opt(li, mid, Ali, Bli, aggf(outVal, y));
		lev--;

		c[lev + 1] = 0;

		lev++;
		dei_opt(mid + 1, ls, A(Ap, Bp), B(Ap, Bp), aggf(outVal, x));
		lev--;
	}
}

void divide_et_impera_opt_sol(void)
{
	int p2;
	rez = lev = 0;
	for (i = 0; i < LMAX; i++)
		c[i] = 0;

	p2 = 1;
	while (p2 < N)
		p2 <<= 1;

	totalOp = 0;
	dei_opt(1, p2, A1, B1, 1);
	fprintf(stderr, "Divide et Impera Opt solution: rez=%d (totalOp=%d)\n", rez, totalOp);
}

void writeOutputData(void)
{
	freopen("xp.out", "w", stdout);
	printf("%d\n", rez);
}

int main()
{
	int tstart = clock();

	readInputData();

	if (N2_SOL)
		n2_sol();
	else
	if (MINV_SOL)
		minv_sol();
	else
	if (N_MLE_SOL)
		n_mle_sol();
	else
	if (N_K_SPLIT_SOL)
		n_k_split_sol();
	else
	if (DIVIDE_ET_IMPERA_SOL)
		divide_et_impera_sol();
	else
	if (DIVIDE_ET_IMPERA_OPT_SOL)
		divide_et_impera_opt_sol();

	writeOutputData();

	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);

	return 0;
}
