#include <iostream>
#include <fstream>
#include <algorithm>
#include <cassert>
#include <memory.h>
using namespace std;

const char iname[] = "petrecere.in";
const char oname[] = "petrecere.out";

#define set(a, d)  (memset(a, 0, sizeof a), a[0] = 1, a[1] = d)
#define copy(a, b) (memcpy(a, b, sizeof a))

void mul(int a[], int d) {
    int i, tr;
    for (i = 1, tr = 0; i <= a[0] || tr > 0; ++ i, tr /= 10)
        a[i] = (tr += a[i] * d) % 10;
    assert(i - 1 <= 3000);
    a[0] = i - 1;
}

void add(int a[], int b[]) {
    int i, tr;
    for (i = 1, tr = 0; i <= a[0] || i <= b[0] || tr > 0; ++ i, tr /= 10)
        a[i] = (tr += a[i] + b[i]) % 10;
    assert(i - 1 <= 3000);
    a[0] = i - 1;
}

int main(void) {
    const int MAX_DIGITS = 3005;
    int a[MAX_DIGITS], b[MAX_DIGITS], c[MAX_DIGITS], n;

    assert(fscanf(fopen(iname, "r"), "%d", &n) == 1);
    assert(1 <= n && n <= 2000);

    if (n == 1)
        set(a, 1);
    else if (n == 2)
        set(a, 2);
    else if (n > 2) {
        set(b, 2), set(c, 1);
        for (int i = 3; i <= n; ++ i) {
            mul(c, i - 1);
            copy(a, b), add(a, c);
            copy(c, b), copy(b, a);
        }
    }

    FILE *fo = fopen(oname, "w");
    for (int i = a[0]; i > 0; -- i)
        fprintf(fo, "%d", a[i]);
    fclose(fo);

    return 0;
}
