// Balan Catalin
// 7 Apr 2010 - 10:18
// ONI 2010 - Proba 1 - submatrix

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>

using namespace std;

#define NMAX 305
#define FIN "submatrix.in"
#define FOUT "submatrix.out"

// PARSARE

#define CHUNK 8192
char g_buf[CHUNK];
int g_p = CHUNK-1;

inline int get()
{
	int x = 0;
	while ( g_buf[g_p] < '0' || g_buf[g_p] > '9' )
		if ( ++g_p >= CHUNK ) { fread(g_buf, 1, CHUNK, stdin); g_p = 0;}

	while ( g_buf[g_p] >= '0' && g_buf[g_p] <= '9' )
	{
		x = x*10+g_buf[g_p]-'0';
		if ( ++g_p >= CHUNK ) { fread(g_buf, 1, CHUNK, stdin); g_p = 0;}
	}
	return x;
}

// END PARSARE

int M[NMAX][NMAX];
int norm[NMAX*NMAX];
int n,m,k;

inline int cmp( int a, int b )
{
	return M[a/NMAX][a%NMAX] < M[b/NMAX][b%NMAX];
}

inline void solve()
{
	int cate[NMAX*NMAX], distinct = 0;
	int st= 1, nm = min(n,m);
	int dr = nm;
	
	int rez = 0;
	while ( st <= dr )
	{
		int sz = (st+dr)>>1;
		// initialize cate
		distinct = 0;
		memset(cate, 0, sizeof(cate));
//		fprintf(stderr, "%d %d %d\n", sz, st, dr);
		for (int i = 1; i <= sz; ++i)
			for (int j = 1; j <= sz; ++j)
			{
				if ( cate[M[i][j]] == 0 ) ++distinct; 
				cate[ M[i][j] ]++;
			}
//		fprintf(stderr, "%d ", distinct);
		if (distinct > k)
		{
			for ( int si = 1; si <= n-sz+1; )
			{
				// fa de la stanga la dreapta
				for ( int j = sz+1; j <= m; ++j )
				{
					// adauga
					for ( int i = si; i <= si+sz-1; ++i )
					{
						if ( cate[ M[i][j] ] == 0 ) ++distinct; 
						   ++cate[ M[i][j] ];
						if ( cate[ M[i][j-sz] ] == 1 ) --distinct;
						   --cate[ M[i][j-sz] ];
					}
					if (distinct <= k) { si = n+2; break; }
//					fprintf(stderr, "%d ", distinct);
				}
				++si;
				if (si > n-sz+1) break;
				// scoate si adauga o linie

				for ( int j = m; j > m-sz; --j )
				{
					if ( cate[ M[si+sz-1][j] ] == 0 ) ++distinct; 
					   ++cate[ M[si+sz-1][j] ];
					if ( cate[ M[si-1][j] ] == 1 ) --distinct;
					   --cate[ M[si-1][j] ];
				}
//				fprintf(stderr, "%d ", distinct);
				if (distinct <= k) break; 
			
				// fa de la dreapta la stanga
				for ( int j = m-sz; j >= 1; --j )
				{
					// adauga
					for ( int i = si; i <= si+sz-1; ++i )
					{
						if ( cate[ M[i][j] ] == 0 ) ++distinct; 
						   ++cate[ M[i][j] ];
						if ( cate[ M[i][j+sz] ] == 1 ) --distinct;
						   --cate[ M[i][j-sz] ];
					}
//					fprintf(stderr, "%d ", distinct);
					if (distinct <= k) { si = n+2; break; } 
				}

				// scoate si adauga o linie
				++si;
				if (si > n-sz+1) break;

				for ( int j = 1; j <= sz; ++j )
				{
					if ( cate[ M[si+sz-1][j] ] == 0 ) ++distinct; 
					   ++cate[ M[si+sz-1][j] ];
					if ( cate[ M[si-1][j] ] == 1 ) --distinct;
					   --cate[ M[si-1][j] ];
				}
//				fprintf(stderr, "%d ", distinct);
				if (distinct <= k) break;
			}
		}
		if (distinct <= k)
		{
			rez = sz;
			st = sz+1;
		} else {
			dr = sz-1;
		}
	}
	printf("%d\n", rez);
	exit(EXIT_SUCCESS);
}

int main()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	n = get();
	m = get();
	k = get();
	for (int i = 1, l = 1; i <= n; ++i)
	{
		for (int j = 1; j <= m; ++j, ++l)
		{
			M[i][j] = get();
			norm[l] = i*NMAX+j;
		}
	}
// NORMALIZARE
	int nm = n*m;
	sort(norm+1, norm+nm+1, cmp);

//	for (int i = 1; i <= nm; ++i)
//		fprintf(stderr, "%d ", M[norm[i]/NMAX][norm[i]%NMAX]);		
//	fprintf(stderr, "\n %d \n", nm);
	int aux = 1, auxn;
	for ( int i = 2; i <= nm; ++i )
	{
		auxn = aux;
		if ( M[norm[i]/NMAX][norm[i]%NMAX] != M[norm[i-1]/NMAX][norm[i-1]%NMAX] ) auxn = aux+1;
		M[norm[i-1]/NMAX][norm[i-1]%NMAX] = aux;
		aux = auxn;
	}
		M[norm[nm]/NMAX][norm[nm]%NMAX] = aux;


//	for (int i = 1; i <= n; ++i)
//	{
//		for (int j = 1; j <= m; ++j)
//			fprintf(stderr, "%d ", M[i][j]);
//		fprintf(stderr, "\n");
//	}

// END NORMALIZARE
	
	solve();

	return EXIT_SUCCESS;
}
