#include <fstream>
#include <iostream>
#include <map>
using namespace std;

const int NMAX = 302;

int N, M, K;
int matr[NMAX][NMAX];

void sum(const int s, map<int, int>& m)
{
	for (int i = 1; i <= s; ++i)
		for (int j = 1; j <= s; ++j)
			m[matr[i][j]]++;
}

void trans(int x1, int y1, int x2, int y2, map<int, int>& m)
{
	int i, j;
	for (j = x1; j <= x2; ++j)
		if (! --m[matr[y1][j]]) m.erase(matr[y1][j]);
	for (i = y1 + 1; i <= y2; ++i)
		if (! --m[matr[i][x1]]) m.erase(matr[i][x1]);
	for (j = x1 + 1; j <= x2 + 1; ++j)
		m[matr[y2 + 1][j]]++;
	for (i = y1 + 1; i <= y2; ++i)
		m[matr[i][x2 + 1]]++;
}

bool find(int i, int i2, int sz, map<int, int>& morig)
{
	map<int, int> mapuse;
	mapuse = morig;
	int x, y;
	for (x = i; x <= M - sz + 1; ++x) {
		for (y = i; y <= i + sz - 1; ++y) {
			if (! --mapuse[matr[y][x]] )
				mapuse.erase(matr[y][x]);
			mapuse[matr[y][x + sz]]++;
		}
		if (mapuse.size() <= (unsigned int)K) return true;
	}
	mapuse.clear();
	mapuse = morig;
	for (y = i; y <= N - sz + 1; ++y) {
		for (x = i; x <= i + sz - 1; ++x) {
			if (! --mapuse[matr[y][x]] )
				mapuse.erase(matr[y][x]);
			mapuse[matr[y + sz][x]]++;
		}
		if (mapuse.size() <= (unsigned int)K) return true;
	}
	return 0;
}

void debug(map<int, int>& x)
{
	cout << x.size() << endl;
	for (int i = 1; i <= 7; ++i)
		cout << i << ": " << x[i] << endl;
}

int solve()
{
	int sz = min(N, M);
	for (int s = sz; s >= 2; --s) {
		map<int, int> initmap;
		sum(s, initmap);
		if ( find(1, 1, s, initmap) ) return s;
		int x1, y1, x2, y2;
		x1 = y1 = 1;
		x2 = y2 = s;
		for (int i = 1; i <= sz - s; ++i) {
			trans(x1, x2, y1, y2, initmap);
			if ( find(++x1, ++y1, s, initmap) ) return s;
		}
	}
	return 1;
}


int main()
{
	ifstream f1("submatrix.in");
	ofstream f2("submatrix.out");
	f1 >> N >> M >> K;
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= M; ++j)
			f1 >> matr[i][j];
	f2 << solve() << endl;
	f2.close();
	return 0;
}
