#include<cstdio>
#include<fstream>
#include<vector>
#include<algorithm>
#define pb push_back
#define INFI 2147483647
#define MAXN 10002
#define MAXM 40002
#define FIN "conex.in"
#define FOUT "conex.out"
using namespace std;

vector<int> G[MAXN], Gt[MAXN];
int n, m, t[MAXN], h[MAXN], nrc;

void solve();

int radacina(int x)
{
    int y=x, tmp;
    while(t[x])
        x=t[x];
    while(t[y])
        tmp=t[y], t[y]=x, y=tmp;
    return x;
}

void uneste(int i, int j)
{
    int ri=radacina(i), rj=radacina(j);
    if(h[ri]<h[rj])
        t[ri]=rj;
    else if(h[rj]<h[ri])
        t[rj]=ri;
    else
        t[rj]=ri, h[ri]++;
    nrc--;
}

void afis()
{
    int i, j;
    printf("%d\n", nrc);
    for(i=1;i<=n;i++)
    {
        printf("%d: ", i);
        for(j=0;j<G[i].size();j++)
            printf("%d ", G[i][j]);
        printf("\n");
    }
    for(i=1;i<=n;i++)
    {
        printf("%d: ", i);
        for(j=0;j<Gt[i].size();j++)
            printf("%d ", Gt[i][j]);
        printf("\n");
    }
    printf("\n");
}

int same(int i, int j)
{
    return radacina(i)==radacina(j);
}

int drum(int x, int y)
{
    for(int i=0;i<G[x].size();i++)
        if(G[x][i]==y)
            return 1;
    return 0;
}

void addmuchii(int x, int y)
{
    int i, j;
    for(i=0;i<G[y].size();i++)
    {
        int rvec=radacina(G[y][i]);
        G[x].pb(rvec);
        Gt[rvec].pb(x);
    }
    /*
    for(i=0;i<Gt[x].size();i++)
    {
        int vechi=radacina(Gt[x][i]);
        for(j=0;j<G[y].size();j++)
        {
            int rvec=radacina(G[y][j]);
            if(vechi!=rvec && vechi!=x && rvec!=x )
            {
                G[vechi].pb(rvec);
                Gt[rvec].pb(vechi);
            }
        }
    }*/
}


int verif(int x ,int y)
{
    int i, j;
    if(same(x, y)==1)
        return 0;
    addmuchii(x, y);
    //afis();
    for(i=0;i<G[x].size();i++)
    {
        int vecin=radacina(G[x][i]);
        if(same(vecin, x)==0)
            if(drum(vecin,x)==1)
                uneste(x, vecin);
    }
    for(i=0;i<Gt[x].size();i++)
    {
        int vechi=radacina(Gt[x][i]);
        for(j=0;j<G[vechi].size();j++)
        {
            int vecin=radacina(G[vechi][j]);
            if(same(vecin, vechi)==0)
                if(drum(vecin,vechi)==1)
                    uneste(vechi, vecin);
        }
    }
    if(nrc==1)
        return 1;
    else
        return 0;
}

int main()
{
    /*freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);*/
    solve();
    return 0;
}

void solve()
{
    int gata=0;
    int x ,y , q=0;
    scanf("%d %d", &n, &m);
    nrc=n;
    if(n==1)
    {
        printf("1\n");
        fflush(stdout);
        gata=1;
    }
    else
    {
        printf("0\n");
        fflush(stdout);
    }
    while(gata==0 && q<m)
    {
        q++;
        scanf("%d %d", &x, &y);
        x=radacina(x);
        y=radacina(y);
        if(x!=y)
        {
            G[x].pb(y);
            Gt[y].pb(x);
        }
        if(verif(x, y)==1)
        {
            gata=1;
            printf("1\n");
            fflush(stdout);
        }
        else
        {
            printf("0\n");
            fflush(stdout);
        }
    }
}

