#include<stdio.h>
#define infile "submatrix.in"
#define outfile "submatrix.out"
#define nmax 313
#define modulo 1313131
struct lista
{
	int v,a,p; //valoarea, numarul de aparitii, respectiv pozitia urmatoare
} l[nmax*nmax]; //lista pentru dispersie
int t[modulo]; //tabela de dispersie
int h[nmax][nmax]; //harta
int n,m; //nr-ul de linii si coloane
int nr; //numarul maxim de elemente distincte
int lmax; //latura maxima
int nrt; //numarul de elemente din tabela
int nrd; //numarul de elemente distincte din tabela

inline int modul(int x)
{
	if(x<0) return -x; return x;
}

inline int min(int a, int b)
{
	if(a<b) return a; return b;
}

inline int f(int x)
{
	return (modul(x)%modulo);
}

int query(int v)
{
	int x=f(v);
	int i;
	for(i=t[x];i;i=l[i].p)
		if(l[i].v==v)
			return i;
	return 0;
}

void push(int v)
{
	int x=f(v);
	int i=query(v);
	if(i)
	{
		if(!l[i].a) ++nrd;
		l[i].a++;
	}
	else
		++nrt, l[nrt].v=v, l[nrt].a=1, l[nrt].p=t[x], t[x]=nrt, ++nrd;
}

void pop(int v)
{
	int i=query(v);
	l[i].a--;
	if(!l[i].a) --nrd;
}

void read()
{
	int i,j;
	scanf("%d %d %d\n",&n,&m,&nr);
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			scanf("%d",&h[i][j]);
}

void erase()
{
	int i;
	for(i=0;i<=nrt;i++)
		t[f(l[i].v)]=0, l[i].v=l[i].a=l[i].p=0;
	nrt=nrd=0;
}

int verif(int l)
{
	int i,j,k;
	if(nrt) erase();
	for(i=1;i<=n-l+1;i++)
	{
		for(j=0;j<l;j++)
			for(k=0;k<l;k++)
				push(h[i+j][1+k]);
		if(nrd<=nr) return 1;
		for(j=l+1;j<=m;j++)
		{
			for(k=0;k<l;k++)
				pop(h[i+k][j-l]), push(h[i+k][j]);
			if(nrd<=nr) return 1;
		}
		erase();
	}
	return 0;
}

void solve()
{
	int st=1,dr=min(n,m),mij;
	while(st<=dr)
	{
		mij=(st+dr)>>1;
		if(verif(mij)) lmax=mij,st=mij+1;
		else dr=mij-1;
	}
}

void write()
{
	printf("%d\n",lmax);
}

int main()
{
	freopen(infile,"r",stdin);
	freopen(outfile,"w",stdout);
	
	read();
	solve();
	write();
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
