#include <cstdio>
#include <vector>

using namespace std;

#define MAXN 10005

int N, M;
vector<bool> used, usedRev;
vector<int> con[MAXN], conT[MAXN];
int NR = 0, NRRev = 0;

inline void dfs(int k) {
    if (used[k]) {
        return;
    }
    used[k] = 1;
    NR += 1;
    vector<int> :: iterator it;
    for (it = con[k].begin(); it != con[k].end(); it++) {
        dfs(*it);
    }
}

inline void dfsRev(int k) {
    if (usedRev[k]) {
        return;
    }
    usedRev[k] = 1;
    NRRev += 1;
    vector<int> :: iterator it;
    for (it = conT[k].begin(); it != conT[k].end(); it++) {
        dfsRev(*it);
    }
}

inline int check(int x, int y) {
    if (used[x]) {
        used[x] = false; NR -= 1;
        dfs(x);
    }

    if (usedRev[y]) {
        usedRev[y] = false; NRRev -= 1;
        dfsRev(y);
    }

    return NR == N && NRRev == N;
}

int main() {
    scanf("%d %d", &N, &M);
    printf("0\n");
    fflush(stdout);

    used.clear(); used.resize(N + 1, false);
    used[1] = true; NR = 1;
    usedRev.clear(); usedRev.resize(N + 1, false);
    usedRev[1] = true; NRRev = 1;

    for (int i = 0; i < M; i++) {
        int x, y;
        scanf("%d %d", &x, &y);
        con[x].push_back(y);
        conT[y].push_back(x);

        if (check(x, y)) {
            printf("1\n");
            fflush(stdout);
            return 0;
        } else {
            printf("0\n");
            fflush(stdout);
        }
    }

    return 0;
}
