#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 305;
const int MAXV = MAXN * MAXN;

vector<int> vals;

int N, M, K;
int m[MAXN][MAXN];
int cnt[MAXV], CNT;

inline void add(int X1, int Y1, int X2, int Y2) {
    for (int i = X1; i <= X2; i++) {
        for (int j = Y1; j <= Y2; j++) {
            cnt[m[i][j]] += 1;
            if (cnt[m[i][j]] == 1) {
                CNT += 1;
            }
        }
    }
}

inline void remove(int X1, int Y1, int X2, int Y2) {
    for (int i = X1; i <= X2; i++) {
        for (int j = Y1; j <= Y2; j++) {
            cnt[m[i][j]] -= 1;
            if (cnt[m[i][j]] == 0) {
                CNT -= 1;
            }
        }
    }
}

inline int isOk(int len) {
    CNT = 0;
    memset(cnt, 0, sizeof(cnt));

    add(0, 0, len - 1, len - 1);

    for (int i = 0; i + len - 1 < N; i++) {
        if (CNT <= K) {
            return 1;
        }

        if (i % 2 == 0) {
            for (int j = 1; j + len - 1 < M; j++) {
                remove(i, j - 1, i + len - 1, j - 1);
                add(i, j + len - 1, i + len - 1, j + len - 1);

                if (CNT <= K) {
                    return 1;
                }
            }

            if (i + len < N) {
                remove(i, M - len, i, M - 1);
                add(i + len, M - len, i + len, M - 1);
            }
        } else {
            for (int j = M - len - 1; j >= 0; j--) {
                remove(i, j + len, i + len - 1, j + len);
                add(i, j, i + len - 1, j);

                if (CNT <= K) {
                    return 1;
                }
            }

            if (i + len < N) {
                remove(i, 0, i, len - 1);
                add(i + len, 0, i + len, len - 1);
            }
        }
    }
    return 0;
}

int main() {
    freopen("submatrix.in", "rt", stdin);
    freopen("submatrix.out", "wt", stdout);

    scanf("%d %d %d", &N, &M, &K);
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < M; j++) {
            scanf("%d", m[i] + j);
            vals.push_back(m[i][j]);
        }
    }
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < M; j++) {
            m[i][j] = lower_bound(vals.begin(), vals.end(), m[i][j]) - vals.begin();
        }
    }

    int rez = 0, step = 1 << 8;
    for (; step; step >>= 1) {
        if (rez + step <= N && rez + step <= M && isOk(rez + step)) {
            rez += step;
        }
    }
    printf("%d\n", rez);

    return 0;
}
