//Gheorghe Cosmin
//Complexitate O(N^2 * K)
#include <stdio.h>
#include <algorithm>
using namespace std;

#define NMAX 310

int N, K, MOD;

int comb[NMAX][NMAX];
int din[NMAX][NMAX];

int get_brut(int N, int K)
{
	int a[N + 10], rez = 0, i;

	a[0] = 0;
	for (i = 1; i <= N; i++) a[i] = i;

	do {
		int k = 0;
		for (i = 1; i <= N; i++) {
			if (a[i] > a[i - 1]) k++;
			else k = 1;
			if (k > K) break;
		}

		rez += i == N + 1;
	} while (next_permutation(a + 1, a + N + 1));

	return rez;
}

int main()
{
	int i, j, k;

	freopen("kmax.in", "r", stdin);
	freopen("kmax.out", "w", stdout);

	scanf("%d %d %d", &N, &K, &MOD);

	comb[0][0] = 1;
	for (i = 1; i <= N; i++) {
		comb[i][0] = 1;
		for (j = 1; j <= i; j++) {
			comb[i][j] = comb[i-1][j-1] + comb[i-1][j];
			if (comb[i][j] >= MOD) comb[i][j] -= MOD;
		}
	}

	int jeg = 0;

	for (i = 1; i <= N; i++) {
		// setez potizia maximului

		for (k = 1; k <= K; k++) {
			din[i][k] = din[i][k - 1];
			if (k > i) continue;
			for (j = 1; j <= i; j++) {
	
//				for (int kk = 1; kk <= k; kk++) jeg += k;

				int dr = (din[i - j][k] - din[i - j][k - 1]);
				if (dr < 0) dr += MOD;
				if (j == i) dr = 1;

				int st = din[j - 1][K - 1];
				if (j == i) {
					st = din[j - 1][k - 1] - din[j - 1][max(0, k - 2)]; 
					if (st < 0) st += MOD; 
				}
				if (j == 1) st = 1;

				din[i][k] += (((st * dr) % MOD) * comb[i - 1][j - 1]) % MOD;

//				printf("%d %d %d -> %d (%d %d)\n", i, k, j, din[i][k], st, dr);

				if (din[i][k] >= MOD) din[i][k] -= MOD;
			}
//			printf("%d %d -> %d\n", i, k, din[i][k]);
		}
	}

	printf("%d\n", din[N][K]);

//	printf("%d\n", jeg);
//	printf("brut = %d\n", get_brut(N, K) % MOD);

	return 0;
}

