// Andrei Grigorean - O(N^3)
#include <cassert>
#include <cstdio>
#include <cstring>

#include <algorithm>
#include <map>
using namespace std;

#define x first
#define y second

const int MAX_N = 300;

int n, m, k;
int a[MAX_N][MAX_N];

int freq[MAX_N * MAX_N];
int distinct;

int best;
int ans[MAX_N][MAX_N];

void read() {
  assert(freopen("submatrix.in", "r", stdin) != NULL);
  assert(freopen("submatrix.out", "w", stdout) != NULL);

  assert(scanf("%d %d %d", &n, &m, &k) == 3);
  assert(1 <= n && n <= MAX_N);
  assert(1 <= m && m <= MAX_N);
  assert(1 <= k && k <= n * m);
  for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
      assert(scanf("%d", &a[i][j]) == 1);
}

void normalize() {
  int values_no = 0;
  map<int, int> values;

  for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
      if (values.find(a[i][j]) == values.end())
        values[a[i][j]] = values_no++;

  for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
      a[i][j] = values[a[i][j]];
}

inline void insert(int x, int y) {
  if (++freq[a[x][y]] == 1) ++distinct;
}

inline void remove(int x, int y) {
  if (--freq[a[x][y]] == 0) --distinct;
}

void solve() {
  normalize();

  pair<int, int> start = make_pair(n - 1, 0);

  for (int step = 0; step < n + m - 1; ++step) {
    pair<int, int> p1 = start;
    pair<int, int> p2 = start;

    distinct = 0;
    memset(freq, 0, sizeof(freq));

    while (p1.x < n && p1.y < m) {
      // Increase the size of the square by 1
      for (int i = 0; i <= (p1.x - p2.x); ++i)
        insert(p1.x - i, p1.y);
      for (int i = 1; i <= (p1.x - p2.x); ++i)
        insert(p1.x, p1.y - i);

      // Decrease the size of the square while necessary
      while (distinct > k) {
        for (int i = 0; i <= (p1.x - p2.x); ++i)
          remove(p2.x + i, p2.y);
        for (int i = 1; i <= (p1.x - p2.x); ++i)
          remove(p2.x, p2.y + i);
        ++p2.x; ++p2.y;
      }

      // Check for solution
      best = max(best, p1.x - p2.x + 1);
      ans[p1.x][p1.y] = p1.x - p2.x + 1;

      ++p1.x; ++p1.y;
    }

    if (start.x == 0) ++start.y;
    else --start.x;
  }
}

void write() {
  printf("%d\n", best);
}

int main() {
  read();
  solve();
  write();
}
