// Andrei Grigorean - O(N^5 log N)
#include <cassert>
#include <cstdio>

#include <algorithm>
#include <set>
using namespace std;

const int MAX_N = 300;

int n, m, k;
int a[MAX_N][MAX_N];
int best;

void read() {
  assert(freopen("submatrix.in", "r", stdin) != NULL);
  assert(freopen("submatrix.out", "w", stdout) != NULL);

  assert(scanf("%d %d %d", &n, &m, &k) == 3);
  assert(1 <= n && n <= MAX_N);
  assert(1 <= m && m <= MAX_N);
  assert(1 <= k && k <= n * m);
  for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
      assert(scanf("%d", &a[i][j]) == 1);
}

void solve() {
  set<int> values;

  for (int x = 0; x < n; ++x)
    for (int y = 0; y < m; ++y)
      for (int size = 1; x + size <= n && y + size <= m; ++size) {
        values.clear();

        for (int i = x; i < x + size; ++i)
          for (int j = y; j < y + size; ++j)
            values.insert(a[i][j]);

        if (int(values.size()) <= k)
          best = max(best, size);
      }
}

void write() {
  printf("%d\n", best);
}

int main() {
  read();
  solve();
  write();
}
