// Andrei Grigorean - O(N^3 log N)
#include <cassert>
#include <cstdio>

#include <algorithm>
#include <map>
using namespace std;

const int MAX_N = 300;

int n, m, k;
int a[MAX_N][MAX_N];

map<int, int> freq;
int distinct;

int best;

void read() {
  assert(freopen("submatrix.in", "r", stdin) != NULL);
  assert(freopen("submatrix.out", "w", stdout) != NULL);

  assert(scanf("%d %d %d", &n, &m, &k) == 3);
  assert(1 <= n && n <= MAX_N);
  assert(1 <= m && m <= MAX_N);
  assert(1 <= k && k <= n * m);
  for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
      assert(scanf("%d", &a[i][j]) == 1);
}

inline void insert(int x, int y) {
  if (++freq[a[x][y]] == 1) ++distinct;
}

inline void remove(int x, int y) {
  if (--freq[a[x][y]] == 0) --distinct;
}

void solve() {
  for (int line = 0; line < n; ++line) {
    freq.clear();
    distinct = 0;

    for (int p1 = 0, p2 = 0; p1 < m; ++p1) {
      // Check for too large squares
      if (p1 - p2 > line) {
        for (int i = 0; i <= line; ++i)
          remove(i, p2);
        for (int i = 1; i < p1 - p2; ++i)
          remove(0, p2 + i);
        ++p2;
      }

      // Increase the size of the square by 1
      for (int i = 0; i <= p1 - p2; ++i)
        insert(line - i, p1);
      for (int i = 0; i < p1 - p2; ++i)
        insert(line - (p1 - p2), p2 + i);

      // Decrease the size of the square while necessary
      while (distinct > k) {
        for (int i = 0; i <= p1 - p2; ++i)
          remove(line - i, p2);
        for (int i = 1; i <= p1 - p2; ++i)
          remove(line - (p1 - p2), p2 + i);
        ++p2;
      }

      // Check for solution
      best = max(best, p1 - p2 + 1);
    }
  }
}

void write() {
  printf("%d\n", best);
}

int main() {
  read();
  solve();
  write();
}
