#include <fstream>
#include <algorithm>

using namespace std;

const int MMAX = 100002;

struct edge_t {
	int a, b, ind;
} esort[MMAX], eorig[MMAX];

inline bool inc(const edge_t x, const edge_t y)
{
	return x.a <= y.a && x.b >= y.b;
}

inline bool comp(const edge_t x, const edge_t y)
{
	return x.a < y.a;
}

bool good(const edge_t es, const edge_t eo)
{
	return (es.ind < eo.ind && es.a <= eo.a);
}

int solve(const edge_t esort[], const edge_t eorig, const int M, const int N)
{
	int m, s;
	for (m = 1; m <= M; m <<= 1);
	for (s = 0; m; m >>= 1)
		if ( s + m <= M && good(esort[s + m], eorig) ) s += m;
	
	if (s && inc(esort[s], eorig)) 
		return eorig.a * (esort[s].b - eorig.b) + (eorig.a - esort[s].a) * (N - eorig.b + 1);
	else 
		return eorig.a * (N - eorig.b + 1);
}

int main()
{
	int N, M, m;
	ifstream f1("minuni.in");
	freopen("minuni.out", "w", stdout);
	f1 >> N >> M;
	for (m = 1; m <= M; ++m) {
		f1 >> eorig[m].a >> eorig[m].b;
		eorig[m].ind = m;
	}
	memcpy(esort, eorig, (M + 1) * sizeof(edge_t));
	sort(esort, esort + M, comp);
	for (m = 1; m <= M; ++m)
		printf("%d\n", solve(esort, eorig[m], M, N));
	return 0;
}
