#include <fstream>
#include <vector>

using namespace std;

const int MAX_N = 100005;
const int MOD = 9973;

ifstream fin ("diff.in");

int N, M, V[MAX_N];
vector <pair <int, int> > H1[MOD];
vector <pair <int, pair <int, int> > > H2[MOD];

void add(int sum, int poz)
{
	int k = sum % MOD;
	if(k < 0) k += MOD;

	H1[k].push_back(make_pair(sum, poz));
}

int find(int sum, int p)
{
	int k = sum % MOD;
	if(k < 0) k += MOD;

	for(vector <pair <int, int> > :: iterator it = H1[k].begin(); it != H1[k].end(); ++it)
		if(it -> first == sum && it -> second < p)
			return it -> second;
	return -1;
}

void brute1()
{
	//hash
	
	add(0, 0);
	int sum = 0;
	for(int i = 1; i <= N; ++i)
	{
		int x;
		fin >> x;
		if(x == 0) --sum;
		else ++sum;
		V[i] = sum;

		add(sum, i);
	}

	for(int i = 1; i <= M; ++i)
	{
		int d, found = 0;
		fin >> d;

		for(int i = 1; i <= N; ++i)
		{
			int p1 = find(V[i] - d, i);
			if(p1 >= 0)
			{
				printf("%d %d\n", p1+1, i);
				found = 1;	
				break;
			}
		}

		if(!found)
			printf("-1\n");
	}
}

void add2(int sum, int i, int j)
{
	int k = sum % MOD;
	if(k < 0) k += MOD;

	H2[k].push_back(make_pair(sum, make_pair(i, j)));
}

pair <int, int> find2(int sum)
{
	int k = sum % MOD;
	if(k < 0) k += MOD;

	for(vector <pair <int, pair <int, int> > > :: iterator it = H2[k].begin(); it != H2[k].end(); ++it)
		if(it -> first == sum)
			return it -> second;

	return make_pair(0, 0);
}

void brute2()
{
	int sum = 0;
	for(int i = 1; i <= N; ++i)
	{
		int x;
		fin >> x;
		if(x == 0) --sum;
		else ++sum;

		V[i] = sum;
	}

	for(int i = 1; i <= N; ++i)
		for(int j = i; j <= N; ++j)
			add2(V[j] - V[i-1], i, j);

	for(int i = 1; i <= M; ++i)
	{
		int x;
		fin >> x;

		pair <int, int> sol = find2(x);
		if(sol.first)
			printf("%d %d\n", sol.first, sol.second);
		else
			printf("-1\n");
	}
}

int main()
{
	freopen("diff.out","wt",stdout);
	fin >> N >> M;

	if(N > 4000)
		brute1();
	else
		brute2();
}
