#include <fstream>

using namespace std;

const int MAX_M = 100005;
const int INF = 0x3f3f3f3f;

ifstream fin ("minuni.in");
ofstream fout ("minuni.out");

int N, M, C[MAX_M], P, Cp[MAX_M], A[MAX_M];
pair <int, int> V[MAX_M];

void citire()
{
	fin >> N >> M;

	for(int i = 1; i <= M; ++i)
	{
		fin >> V[i].first >> V[i].second;
		C[i] = V[i].first;
	}
}

inline int lsb (int x)
{
	return (x & -x);
}

void norm()
{
	sort(C+1, C+M+1);
	P = unique(C+1, C+M+1) - C-1;
}

void update(int x)
{
	for(int i = x; i <= P; i += lsb(i))
		A[i] = max(A[i], x);
}

int find(int x)
{
	int sol = 0;
	for(; x; x -= lsb(x))
		sol = max(sol, A[x]);
	return sol;
}

void solve()
{
	memset(Cp, INF, sizeof Cp);

	for(int i = 1; i <= M; ++i)
	{
		int x = lower_bound(C+1, C+P+1, V[i].first) - C;
		int y = find(x);

		long long sol = 0;
		if(y == 0 || Cp[y] < V[i].second)
			sol = 1LL * V[i].first * 1LL*(N - V[i].second+1);
		else
			sol = 1LL * (V[i].first) * 1LL * (N - V[i].second+1) - 1LL * C[y] * (N - Cp[y] + 1); 

		Cp[x] = min(Cp[x], V[i].second);
		update(x);

		fout << sol << "\n";
	}
}

int main()
{
	citire();
	norm();
	solve();
}
