#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXM 100005
#define MAXT 262144
#define LL long long

int N, M;
int L[MAXM], R[MAXM];
vector<int> v;
int aint[MAXT];

#define AINTCOMMON int m = (l + r) >> 1, lc = (n << 1), rc = (lc + 1)

int QL, QR;
inline int query(int n, int l, int r) {
    if (QL <= l && r <= QR) {
        return aint[n];
    }

    AINTCOMMON;
    int rez = 0;
    if (QL <= m) {
        rez = max(rez, query(lc, l, m));
    }
    if (QR > m) {
        rez = max(rez, query(rc, m + 1, r));
    }
    return rez;
}

int UP, UV;
inline void update(int n, int l, int r) {
    if (l == r) {
        aint[n] = UV;
        return;
    }

    AINTCOMMON;
    if (UP <= m) {
        update(lc, l, m);
    } else {
        update(rc, m + 1, r);
    }
    aint[n] = max(aint[lc], aint[rc]);
}

int main() {
    freopen("minuni.in", "rt", stdin);
    freopen("minuni.out", "wt", stdout);

    scanf("%d %d", &N, &M);
    for (int i = 0; i < M; i++) {
        scanf("%d %d", L + i, R + i);
        v.push_back(L[i]);
        v.push_back(R[i]);
    }
    sort(v.begin(), v.end());

    for (int i = 0; i < M; i++) {
        int Lnorm = lower_bound(v.begin(), v.end(), L[i]) - v.begin();
        UP = Lnorm; UV = R[i];
        update(1, 0, N - 1);

        QL = 0; QR = Lnorm;
        if (query(1, 0, N - 1) == R[i]) {
            // Interval is not contained
            printf("%lld\n", L[i] * ((LL)N - R[i] + 1));
        } else {
            int _L = Lnorm, step = 1 << 17;
            for (; step; step >>= 1) {
                if (_L - step >= 0) {
                    QL = _L - step; QR = Lnorm;
                    if (query(1, 0, N - 1) == R[i]) {
                        _L -= step;
                    }
                }
            }
            QL = _L - 1; QR = Lnorm;
            int _R = query(1, 0, N - 1);
            _L = v[_L - 1];

            printf("%lld\n", _L * ((LL)_R - R[i]) + ((LL)L[i] - _L) * ((LL)N - R[i] + 1));
        }
    }

    return 0;
}
