#include <stdio.h>
#include <map>
using namespace std;

struct minisol {
	long start;
	long end;
	minisol(long _start, long _end);
};
minisol::minisol(long _start, long _end) {
	start=_start;
	end=_end;
}

#define NMAX 100001
#define MMAX 200001

long n, m;
char v[NMAX];
long long k[MMAX];
long long prec[NMAX];
map<long long, minisol> sol;

int main (void) {
	FILE * fi = fopen("diff.in","rt");
	FILE * fo = fopen("diff.out","wt");

	fscanf(fi,"%ld %ld",&n,&m);
	for (long i=0; i<n; i++) {
		int dummy;
		fscanf(fi,"%d",&dummy);
		if (dummy==0) v[i]=0; else v[i]=1;
	}

	long acur=0;
	long bcur=0;

	for (long i=0; i<n; i++) {
		if (v[i]==1) acur++;
		else bcur++;
		prec[i]=acur-bcur;
	}

	for (long i=-1; i<n; i++)
		for (long j=i+1; j<n; j++) {
			long long diff;
			if (i==-1) diff=prec[j];
			else diff=prec[j]-prec[i];
			
			if (sol.find(diff)==sol.end()) {
				minisol sl(i,j);
				sol.insert(make_pair(diff,sl));
			}
		}

	for (long i=0; i<m; i++) {
		long ki;
		fscanf(fi,"%ld",&ki);
		map<long long,minisol>::iterator f = sol.find(ki);
		if (f==sol.end())
			fprintf(fo,"-1\n");
		else 
			fprintf(fo,"%ld %ld\n",f->second.start+2,f->second.end+1);
	}
	/*for (long i=0; i<n; i++)
		fprintf(stderr,"%ld ",prec[i]);
	fprintf(stderr,"\n");*/

	fclose(fi);
	fclose(fo);
	return 0;
}