#include <stdio.h>
#include <memory.h>
#include <limits.h>

#define NMAX 51
long n, E;
long d[NMAX];
int speed[NMAX];
double inter;

double dabs(double x) {
	if (x<0) return -x; else return x;
}

long getcurbest() {
	long maxdist=0;
	for (long i=0; i<n-2; i++)
		if (d[i+1]-d[i]>maxdist) maxdist=d[i+1]-d[i];
	return maxdist;
}

char backed[NMAX];
long btbestsol;
void back(long eff) {
	if (eff==0) {
		long maxdist=getcurbest();
		if (maxdist<btbestsol) btbestsol=maxdist;

/*
		fprintf(stderr,"DEBUG: bt: ");
		for (long j=10; j>eff; j--) fprintf(stderr,"*");
		fprintf(stderr,": largest distance is %ld\n",maxdist);
*/

	} else {
		for (long i=0; i<n-2; i++)
			if (!backed[i] && (speed[i]!=0)) {
				backed[i]=1;
				long imspeed;
				if ((double)d[i]<double(i+1)*inter) {
					imspeed=1;
				}
				else {
					imspeed=-1;
				}
				d[i]+=imspeed;

/*
				fprintf(stderr,"DEBUG: bt: ");
				for (long j=10; j>eff; j--) fprintf(stderr,"*");
				fprintf(stderr,": spending effort on tree %ld\n",i);
*/

				back(eff-1);

				d[i]-=imspeed;			
				backed[i]=0;
			}
	}
}

int main (void) {
	FILE * fi = fopen("stalpi.in","rt");
	FILE * fo = fopen("stalpi.out","wt");

	fscanf(fi,"%ld %ld",&n,&E);
	for (long i=0; i<n-1; i++)
		fscanf(fi,"%ld",&d[i]);
	double total = d[n-2];
	inter = total/double(n-1);
	//fprintf(stderr,"DEBUG: precalc(): calculated ideal positions every %f\n",inter);
	long moving=0;
	for (long i=0; i<n-2; i++) {
		if (dabs((double)d[i]-double(i+1)*inter)<1.0)
			speed[i]=0;
		else if ((double)d[i]<double(i+1)*inter) {
			speed[i]=1;
			moving++;
		}
		else {
			speed[i]=-1;
			moving++;
		}
	}
	long eff=E;
	while (eff>=moving && moving!=0) {
//		fprintf(stderr,"DEBUG: new round. effort left=%ld, trees moving=%ld\n",eff,moving);
		for (long i=0; i<n-2; i++)
			if (speed[i]!=0) {
//				fprintf(stderr,"DEBUG: moved tree %ld from %ld to %ld\n",i,d[i],d[i]+speed[i]);
				d[i]+=speed[i];
				eff--;
				if (dabs((double)(d[i])-double(i+1)*inter)<1.0) {
//					fprintf(stderr,"DEBUG:            ...became stationary\n");
					speed[i]=0;
					moving--;
				}
			}
	}
	if (eff>0) {
		if (moving==0) {
//			fprintf(stderr,"DEBUG: effort remaining: %ld. no moving trees.\n",eff);

			long maxdist=getcurbest();
			fprintf(fo,"%ld\n",maxdist);
		} else {
//			fprintf(stderr,"DEBUG: effort remaining: %ld. backtracking.\n",eff);
			btbestsol=LONG_MAX;

			memset(backed,0,sizeof(backed));
			back(eff);
			fprintf(fo,"%ld\n",btbestsol);
		}
	} else {
//		fprintf(stderr,"DEBUG: no effort remaining. nothing to backtrack.\n");

		long maxdist=getcurbest();
		fprintf(fo,"%ld\n",maxdist);
	}

	fclose(fi);
	fclose(fo);
	return 0;
}