#include <stdio.h>

#define NMAX 100002
#define SHIFT 100000

int N, M;
int Hst[2 * NMAX], Hdr[2 * NMAX];
int V[NMAX];
int S[NMAX];

void init_hash() {
  int i;

  for (i = 0; i <= 2 * NMAX; i++) {
    Hst[i] = -1;
    Hdr[i] = -1;
  }
}

void build_hash() {
  int i;
  int min = 0;
  int max = 0;
  int pmin = 0;
  int pmax = 0;
  for (i = 1; i <= N; i++) {
    int x, y;
    x = S[i] - max;
    y = S[i] - min;

    Hst[SHIFT + x] = pmax;
    Hdr[SHIFT + x] = i;

    Hst[SHIFT + y] = pmin;
    Hdr[SHIFT + y] = i;

    if (S[i] < min) {
      min = S[i];
      pmin = i;
    }

    if (S[i] > max) {
      max = S[i];
      pmax = i;
    }
  }
}

int main() {
  freopen("diff.in", "r", stdin);
  freopen("diff.out", "w", stdout);

  scanf("%d %d ", &N, &M);

  int i;
  for (i = 1; i <= N; i++) {
    scanf("%d ", &V[i]);

    if (V[i] == 0) {
      V[i] = -1;
    }

    S[i] = S[i - 1] + V[i];
  }

  init_hash();
  build_hash();

  for (i = 1; i <= M; i++) {
    int D;
    scanf("%d ", &D);

    if (Hst[SHIFT + D] == -1) {
      printf("-1\n");
    } else {
      printf("%d %d\n", Hst[SHIFT + D] + 1, Hdr[SHIFT + D]);
    }
  }

  return 0;
}
