#include <cassert>
#include <cstdio>

#include <algorithm>
using namespace std;

const int MAX_N = 100000;
const int INF = 0x3f3f3f3f;
const int MAX_S = 1000000000;

int n, m;
int v[MAX_N];

pair<int, int> answer[2 * MAX_N + 1];
#define answer (answer + MAX_N)

void do_the_monkey(int pos, int add) {
  int sum = 0;
  for (int i = pos; 0 <= i && i < n; i += add) {
    sum += v[i];
    answer[sum] = make_pair(min(pos, i) + 1, max(pos, i) + 1);
  }
}

int main() {
  assert(freopen("diff.in", "r", stdin) != NULL);
  assert(freopen("diff.out", "w", stdout) != NULL);

  assert(scanf("%d %d", &n, &m) == 2);
  assert(1 <= n && n <= MAX_N);
  assert(1 <= m && m <= 2 * n);

  for (int i = 0; i < n; ++i) {
    assert(scanf("%d", &v[i]) == 1);
    assert(v[i] == 0 || v[i] == 1);
    if (!v[i]) v[i] = -1;
  }

  do_the_monkey(0, 1);
  do_the_monkey(n-1, -1);

  int minSum = INF, posMin = -1;
  int maxSum = -INF, posMax = -1;
  int sum = 0;
  for (int i = 0; i < n; ++i) {
    sum += v[i];
    if (sum < minSum) {
      minSum = sum;
      posMin = i;
    }
    if (sum > maxSum) {
      maxSum = sum;
      posMax = i;
    }
  }

  do_the_monkey(posMin, 1);
  do_the_monkey(posMin, -1);
  do_the_monkey(posMax, 1);
  do_the_monkey(posMax, -1);

  for (int i = 0; i < m; ++i) {
    int sum;
    assert(scanf("%d", &sum) == 1);
    assert(-MAX_S <= sum && sum <= MAX_S);

    if (answer[sum].first == 0)
      printf("-1\n");
    else
      printf("%d %d\n", answer[sum].first, answer[sum].second);
  }
}
