/*
	Airinei Adrian
	Complexitate O(X^2), X = adancimea maxima a secventei parantezate
*/
#include <cstdio>
#include <cstring>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

#define MAXN 100100
#define llong long long
#define MAXARB (1<<18)
#define left (nod << 1)
#define right ((nod << 1) | 1)
#define mid ((st+dr) >> 1)

int N, M;
int viz[MAXN], Ind[MAXN], T[MAXN];
pair<int, int> query[MAXN], A[2*MAXN];


void preproc(void)
{
	int i, j, k, timp = 0;
	for(i = 1; i <= M; i++)
		A[i].first = query[i].first, A[i].second = i,
		A[M+i].first = query[i].second, A[M+i].second = i;
	sort(A+1, A+2*M+1);
	for(i = 1; i <= 2*M; i++)
	{
		if(viz[A[i].second] == 0) // deschid
		{
			viz[A[i].second] = 1;
            for(j = timp; j >= 1; j--)
                if(T[j] < A[i].second)
                    break ;
            Ind[A[i].second] = T[j];
			T[++timp] = A[i].second;
		}
		else // inchid
		{
			timp--;
        }
	}
}

void read_and_solve(void)
{
	int i, j, k, a, b;

	scanf("%d %d\n", &N, &M);

	for(i = 1; i <= M; i++)
	{
		scanf("%d %d\n", &a, &b);
		query[i].first = a, query[i].second = b;
	}

	preproc();

	for(i = 1; i <= M; i++)
	{
		if(Ind[i] == 0)
			printf("%lld\n", (llong)query[i].first*(N-query[i].second+1));
		else
		{
			int p = query[Ind[i]].first, q = query[Ind[i]].second;
			a = query[i].first, b = query[i].second;
			printf("%lld\n", (llong)a*(q-b)+(llong)(a-p)*(N-b+1)-(llong)(a-p)*(q-b));
		}
	}
}

int main(void)
{
	freopen("minuni.in", "rt", stdin);
	freopen("minuni.out", "wt", stdout);

	read_and_solve();

	return 0;
}





