#include <cstdio>
#include <cstdlib>
#include <vector>
#include <queue>
#include <bitset>
#include <algorithm>
using namespace std;

#define NMAX 100042

// PARSARE

#define CHUNK 8192
char Pbuf[CHUNK];
int Pp = CHUNK-1;
inline int get()
{
	while (Pbuf[Pp] < '0' || Pbuf[Pp] > '9')
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	int x = 0;	


	while (Pbuf[Pp] >= '0' && Pbuf[Pp] <= '9')
	{
		x = x*10+Pbuf[Pp]-'0';
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	}
	return x;

}

// END PARSARE

#define INF 0x3f3f3f3f

struct edg
{
	int y, dst, cst;
};
vector<edg> G[NMAX];
queue<int> Q;

int dist[NMAX];
int distmax[NMAX];
int parent[NMAX];
int frunze[NMAX];
bitset<NMAX> frunza;
int cost[NMAX], cost2[NMAX];
int nrfrunze[NMAX];
vector<int> care[NMAX];

// HEAP

int heap[NMAX], pos[NMAX];

inline void swapH( int p, int q )
{
	int aux = heap[p];
	heap[p] = heap[q];
	heap[q] = aux;
	pos[heap[p]] = p;
	pos[heap[q]] = q;
}

inline void upheap( int p )
{
	while ( p>>1 && (cost2[heap[p>>1]] > cost2[heap[p]]) )
	{
		swapH(p>>1, p);
		p>>=1;
	}

}

inline void downheap( int p, int L )
{
	int q = 0, w;
	while ( q!=p )
	{
		q = p;
		w = q<<1;
		if ( w <= L && cost2[heap[w]] < cost2[heap[p]] ) p = w;
		++w;
		if ( w <= L && cost2[heap[w]] < cost2[heap[p]] ) p = w;
		swapH(p,q);
	}
}

// END HEAP

inline void BF( int start, int n )
{
	parent[start] = 0;
	dist[start] = 0;
	for (int i = 2; i <= n; ++i)
		dist[i] = INF;
	Q.push(start);
	while (!Q.empty())
	{
		int nod = Q.front();
		Q.pop();
		int sz = G[nod].size();
		for (int i = 0; i < sz; ++i)
		{
			int nx = G[nod][i].y;
			while (dist[ nx ] != INF)
			{
				G[nod][i] = G[nod].back();
				G[nod].pop_back();
				--sz;
				nx = G[nod][i].y;
			}
			frunza[nod] = false;
			frunza[nx] = true;
			dist[nx] = dist[nod] + G[nod][i].dst;
			parent[nx] = nod;
			cost[nx] = G[nod][i].cst;
			cost2[nx] = (n-1)*cost[nx];
			Q.push(nx);
		}
	}

}

inline bool cmp( int a, int b )
{
	return dist[a] > dist[b];
}

int main()
{
	freopen("arb.in", "r", stdin);
	freopen("arb.out", "w", stdout);

	int n = get();
	for (int i = 1; i < n; ++i)
	{
		int x = get();
		edg q;
		q.y = get();
		q.dst = get();
		q.cst = get();
		G[x].push_back(q);
	}

	BF(1, n);

	int nrf = 0;
	for (int i = 1; i <= n; ++i)
	{
		if (!frunza[i]) continue;
		frunze[++nrf] = i;
	}
	sort(frunze+1, frunze+nrf+1, cmp);

	while (!Q.empty()) Q.pop();
	for (int i = 1; i <= nrf; ++i)
	{
		Q.push(frunze[i]);
		nrfrunze[frunze[i]] = 1;
		care[frunze[i]].push_back(frunze[i]);
	}
	frunza.reset(false);
	while (!Q.empty())
	{
		vector<int>::iterator it;
		int nod = Q.front();
		Q.pop();
		if (nod == 1) continue;
		if (frunza[nod] == false) continue;
		frunza[nod] = true;
		nrfrunze[parent[nod]]++;
		Q.push(parent[nod]);
		for (it = care[nod].begin(); it != care[nod].end(); ++it)
			care[parent[nod]].push_back(*it);
	}
	for (int i = 2; i <= n; ++i)
	{
		cost2[i]/=nrfrunze[i];
	}
	
	int frunzeNesat = nrf;

	for ( int i = 1; i <= nrf && dist[frunze[i]] == dist[frunze[1]]; ++i)
	{
		--frunzeNesat;
		int q = frunze[i];
		while (parent[q] != 0)
		{
			cost2[q] = INF;
			int p = parent[q];
			parent[q] = 0;
			q = p;
		}
	}
	int L = 0;
	for (int i = 2; i <= n; ++i)
	{
		if (parent[i] == 0) continue;
		heap[++L] = i;
		pos[i] = L;
		upheap(L);
	}


	int costTot = 0;
	while (frunzeNesat > 0)
	{
		int m = heap[1];
		int maxim = 0;
		vector<int>::iterator it;
		for (it = care[m].begin(); it != care[m].end(); ++it)
		{
			if (dist[*it] > maxim) maxim = dist[*it];
		}
		int update = dist[frunze[1]] - maxim;
		costTot += update*cost[m];
		for (it = care[m].begin(); it != care[m].end(); ++it)
		{
			dist[*it] += update;
			if (dist[*it] == dist[frunze[1]]) --frunzeNesat;
		}
		while (m != 0)
		{
			if (parent[m] <= 1) { m = 0; continue; }
			cost2[m] = INF;
			swapH(pos[m], L);
			--L;
			upheap(L);
			int p = parent[m];
			parent[m] = 0;
			m = p;
		}
	}

	printf("%d\n",costTot);

	return EXIT_SUCCESS;
}

