// BALAN CATALIN
// 11 Apr 2010 - 8:11
// ONI 2010 - Baraj 2 - cuiburi

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <queue>
using namespace std;

// PARSARE

#define CHUNK 8192
char Pbuf[CHUNK];
int Pp = CHUNK-1;
inline int get()
{
	while (Pbuf[Pp] < '0' || Pbuf[Pp] > '9')
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	int x = 0;	


	while (Pbuf[Pp] >= '0' && Pbuf[Pp] <= '9')
	{
		x = x*10+Pbuf[Pp]-'0';
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	}
	return x;

}

// END PARSARE

#define NMAX 2002

struct cuib
{
	bool type;  // 1 - cerc, 0 - dreptunghi
	int x1, y1;
	int x2, y2; // x2 e raza daca e cerc
};
cuib cb[NMAX];

vector<int> G[NMAX];
queue<int> Q;
int depth[NMAX];
int grad[NMAX];
inline int dist( int x1, int y1, int x2, int y2 )
{
	x1-=x2;
	y1-=y2;
	return (x1*x1)+(y1*y1);
}

inline int max( int a, int b )
{
	return a>b?a:b;
}

// j este inclus in i
inline bool inclus( int i, int j )
{
	// Drept > Drept
	if ( cb[i].type == 0 && cb[j].type == 0 )
	{
		if ( cb[i].x1 <= cb[j].x1 && 
			 cb[i].y1 <= cb[j].y1 && 
			 cb[i].x2 >= cb[j].x2 && 
			 cb[i].y2 >= cb[j].y2 ) return true;
		return false;
	}
	// Drept > Cerc
	if ( cb[i].type == 0 && cb[j].type == 1 )
	{
		if ( cb[i].x1 <= cb[j].x1-cb[j].x2 && 
			 cb[i].y1 <= cb[j].y1-cb[j].x2 && 
			 cb[i].x2 >= cb[j].x1+cb[j].x2 && 
			 cb[i].y2 >= cb[j].y1+cb[j].x2 ) return true;
		return false;
	}
	// Cerc > Drept
	if ( cb[i].type == 1 && cb[j].type == 0 )
	{
		int r = cb[i].x2*cb[i].x2;
		if ( dist( cb[i].x1, cb[i].y1, cb[j].x1, cb[j].y1 ) <= r && 
			 dist( cb[i].x1, cb[i].y1, cb[j].x1, cb[j].y2 ) <= r && 
			 dist( cb[i].x1, cb[i].y1, cb[j].x2, cb[j].y1 ) <= r && 
			 dist( cb[i].x1, cb[i].y1, cb[j].x2, cb[j].y2 ) <= r ) return true;
		return false;
	}
	// Cerc > Cerc
	if ( cb[i].type == 1 && cb[j].type == 1  )
	{
		int ri = cb[i].x2*cb[i].x2;
		int rj = cb[j].x2*cb[j].x2;
		if ( dist( cb[i].x1, cb[i].y1, cb[j].x1, cb[j].y1 ) + rj <= ri ) return true;
		return false;
	}
}

int main()
{
	freopen("cuiburi.in", "r", stdin);
	freopen("cuiburi.out", "w", stdout);

	int n = get();
	for (int i = 1; i <= n; ++i)
	{
		cb[i].type = get();
		cb[i].x1 = get();
		cb[i].y1 = get();
		cb[i].x2 = get();
		if (!cb[i].type) cb[i].y2 = get();
	}

	for (int i = 1; i < n; ++i)
	{
		G[i].push_back(0);
		for (int j = i+1; j <= n; ++j)
		{
			if (inclus( i, j ))
			{
				G[j].push_back(i);
				++grad[i];
//				fprintf(stderr, "%d > %d\n", i, j);
			}
			else if (inclus(j, i))
			{
				G[i].push_back(j);
				++grad[j];
//				fprintf(stderr, "%d > %d\n", j, i);
			}
		}
	}
	G[n].push_back(0);
	depth[0] = 0;
	grad[0] = n+n;
	for (int i = 1; i <= n; ++i)
	{
		depth[i] = 0;
		if (grad[i] == 0) Q.push(i);
	}

	while (!Q.empty())
	{
		int nod = Q.front();
		Q.pop();
		vector<int>::iterator it;
		for (it = G[nod].begin(); it != G[nod].end(); ++it)
		{
			depth[*it] = max( depth[*it], 1+depth[nod] );
			--grad[*it];
			if (grad[*it] == 0) Q.push(*it);
		}
	}

	printf("%d", depth[0]);




	return EXIT_SUCCESS;
}

