#include <fstream.h>
#include <math.h>

ifstream fi("cuiburi.in");
ofstream fo("cuiburi.out");

struct cuibareala{
	int t,sx,sy,dx,dy;
	int cx,cy;
	float raza;
};

int a[2002][2002],n,v[2002],distMax;
cuibareala cuib[2002];

void citire(){
	int i;
	fi>>n;
	for(i=1;i<=n;i++){
		fi>>cuib[i].t;
		if(cuib[i].t==0){
			fi>>cuib[i].sx;
			fi>>cuib[i].sy;
			fi>>cuib[i].dx;
			fi>>cuib[i].dy;
		}
		else{
			fi>>cuib[i].cx;
			fi>>cuib[i].cy;
			fi>>cuib[i].raza;
		}
	}
	fi.close();
}

void verificaDD(int i,int j){
	if(cuib[i].sx<=cuib[j].sx && cuib[i].sy<=cuib[j].sy && cuib[i].dx>=cuib[j].dx && cuib[i].dy>=cuib[j].dy)
		a[i][j]=1;
	if(cuib[j].sx<=cuib[i].sx && cuib[j].sy<=cuib[i].sy && cuib[j].dx>=cuib[i].dx && cuib[j].dy>=cuib[i].dy)
		a[j][i]=1;
}

void verificaCC(int i,int j){
	float dist=sqrt((cuib[i].cx-cuib[j].cx)*(cuib[i].cx*cuib[j].cx)+(cuib[i].cy-cuib[j].cy)*(cuib[i].cy-cuib[j].cy));
	if(cuib[i].raza>=dist+cuib[j].raza)
		a[i][j]=1;
	if(cuib[j].raza>=dist+cuib[i].raza)
		a[j][i]=1;
}

void verificaCD(int i,int j){
	float distSJ,distSS,distDJ,distDS;
	distSJ=sqrt((cuib[j].sx-cuib[i].cx)*(cuib[j].sx-cuib[i].cx)+(cuib[j].sy-cuib[i].cy)*(cuib[j].sy-cuib[i].cy));
	distSS=sqrt((cuib[j].sx-cuib[i].cx)*(cuib[j].sx-cuib[i].cx)+(cuib[j].dy-cuib[i].cy)*(cuib[j].dy-cuib[i].cy));
	distDJ=sqrt((cuib[j].dx-cuib[i].cx)*(cuib[j].dx-cuib[i].cx)+(cuib[j].sy-cuib[i].cy)*(cuib[j].sy-cuib[i].cy));
	distDS=sqrt((cuib[j].dx-cuib[i].cx)*(cuib[j].dx-cuib[i].cx)+(cuib[j].dy-cuib[i].cy)*(cuib[j].dy-cuib[i].cy));
	if(distSJ<=cuib[i].raza && distSS<=cuib[i].raza && distDJ<=cuib[i].raza && distDS<=cuib[i].raza)
		a[i][j]=1;
}
	
void verificaDC(int i,int j){		
	if(cuib[j].cx+cuib[j].raza<=cuib[i].dx && cuib[j].cx-cuib[j].raza>=cuib[i].sx && cuib[j].cy+cuib[j].raza<=cuib[i].dy && cuib[j].cy-cuib[j].raza>=cuib[i].sy)
		a[i][j]=1;
}

void afisare(){
	fo<<distMax<<'\n';
	fo.close();
}

void verificaA(){
	int i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			if(i!=j){
				if(cuib[i].t==0 && cuib[j].t==0)
					verificaDD(i,j);
				else if(cuib[i].t==1 && cuib[j].t==1)
					verificaCC(i,j);
				else if(cuib[i].t==1 && cuib[j].t==0)
					verificaCD(i,j);
				else if(cuib[i].t==0 && cuib[j].t==1)
					verificaDC(i,j);
			}
}

void adancime(int k,int dist){
	if(distMax<dist)
		distMax=dist;
	v[k]=1;
	int i;
	for(i=1;i<=n;i++)
		if(a[k][i]==1 && v[i]==0)
			adancime(i,dist+1);
	v[k]=0;
}
			
int main(){
	citire();
	verificaA();
	int i;
	for(i=1;i<=n;i++)
		adancime(i,1);
	afisare();
	return 0;
}


