#include<cstdio>
#include<cmath>
#include<vector>
#include<algorithm>
#define f first
#define s second
#define elif else if
using namespace std;
const double eps = 0.00001;
const int maxn = 3005;
int i , j , n , lx , ly , rx , ry , x , y, r , k , l; 
int type[maxn];
int result[maxn];
int ind[maxn];
int maxs;
vector < int > G[maxn];

inline double d_abs ( double x ) {
	if ( x < 0 ) return -x;
return x;
}

struct point { 
	int x , y;
};
struct cerc { 
	point centru;
	int r ;
};
struct drept {
	point sus;
	point jos;
};

vector < drept > rect;
vector < cerc > circle;


double dist ( point A , point B ) {
	return (sqrt((double) (B.x - A.x) * (B.x - A.x ) + (B.y - A.y) * ( B.y - A.y) ) );
}

bool pnct_cerc ( point A , cerc B ) {
	if ( d_abs ( dist ( A , B.centru ) - B.r ) < eps ) return true;
	if ( dist ( A , B.centru ) < B.r )  return true;
return false;
}

bool pnct_drept ( point A , drept B ) {
	if ( A.x >= B.jos.x && A.x <= B.sus.x && A.y >= B.jos.y && A.y <= B.sus.y ) return true;
return false;
}

bool cerc_drept ( cerc A , drept B ) {
	
	if ( pnct_drept ( A.centru , B ) == false ) return false;
	
	point up , low , left , right;
	up.x = A.centru.x - A.r , up.y = A.centru.y;
	low.x = A.centru.x + A.r , low.y = A.centru.y;
	left.x = A.centru.x , left.y = A.centru.y - A.r;
	right.x = A.centru.x , right.y = A.centru.y + A.r;
	
	if( pnct_drept ( up , B ) && pnct_drept( low , B ) && pnct_drept( left , B ) && pnct_drept ( right , B ) ) return true;
return false;
}

bool drept_drept ( drept A , drept B ) {
	if ( pnct_drept ( A.sus , B ) && pnct_drept ( A.jos , B )) return true;
return false;
}

bool drept_cerc ( drept A , cerc B ) {
	if ( pnct_cerc( A.jos , B ) && pnct_cerc ( A.sus , B ) ) return true;
return false;
}

bool cerc_cerc ( cerc A , cerc B ) {
	if ( pnct_cerc (A.centru , B ) == false ) return false;
	if (d_abs( dist ( A.centru , B.centru ) + A.r - B.r) < eps ) return true;
	if ( dist ( A.centru , B.centru ) + A.r < B.r ) return true;
}

int go (int node ) {
	if ( result[node] ) return result[node];
	int rez = 0;
	int i , act;
	for( i = 0 ; i < G[node].size() ; ++i ) {
		act = G[node][i];
		rez = max (go(act) , rez);
	}
result[node] = rez + 1;
if ( result[node] > maxs ) maxs = result[node];
return result[node];
}

int main()
{
	freopen("cuiburi.in","r",stdin);
	freopen("cuiburi.out","w",stdout);
	
	
	scanf("%d",&n);
	
	for( i = 1 ; i <= n ; ++i ) {
		scanf("%d",&type[i]);
		if ( type[i] == 0 ) {
			drept A;
			scanf("%d %d %d %d",&A.jos.x,&A.jos.y,&A.sus.x,&A.sus.y ) ;
			rect.push_back(A);
			ind[i] = k++;
		}
		else {
			cerc A;
			scanf("%d %d %d",&A.centru.x,&A.centru.y,&A.r);
			circle.push_back(A);
			ind[i] = l++;
		}
	}
	
	
	for( i = 1 ; i <= n ; ++i )
		for( j = i + 1 ; j <= n ; ++j ) {
			if ( type[i] == 0 && type[j] == 0 ) {
				if  ( drept_drept ( rect[ind[i]] , rect[ind[j]] ) ) 
					G[j].push_back(i);
				elif ( drept_drept( rect[ind[j]] , rect[ind[i]] ) ) 
					G[i].push_back(j);
				}
			elif ( type[i] == 0 && type[j] == 1 ) {
				if ( drept_cerc ( rect[ind[i]] , circle[ind[j]] ) ) 
					G[j].push_back(i);
				if ( cerc_drept(circle[ind[j]] , rect[ind[i]] ) )
					G[i].push_back(j);
			}
			elif ( type[i] == 1 && type[j] == 0 ) {
				if ( cerc_drept ( circle[ind[i]] , rect[ind[j]] ) ) 
					G[j].push_back(i);
				if ( drept_cerc ( rect[ind[j]] , circle[ind[i]] ) ) 
					G[i].push_back(j);
			}
			elif ( type[i] == 1 && type[j] == 1 ) {
				if ( cerc_cerc ( circle[ind[i]] , circle[ind[j]] ) ) 
					G[j].push_back(i);
				elif ( cerc_cerc( circle[ind[j]] , circle[ind[i]] ) )
					G[i].push_back(j);
			}
		}
		
	for( i = 1 ; i <= n ; ++i ) 
		if ( result[i] == 0 ) go(i);
		
	printf("%d\n",maxs);
return 0;
}