#include <stdio.h>
#include <algorithm>
#include <math.h>
using namespace std;
#define NMAX 2048
#define pi 3.14159265
struct drep{
	int x1, y1, x2, y2, t, r;
	double a;
};
struct comp{
	bool operator()(const drep &a, const drep &b){
		return a.a < b.a;
	}
};
drep v[NMAX];
int T[NMAX];
int n, sol;
inline int abs(int x){
	if(x > 0) return x;
	return -x; 
}
inline double dist(int x1, int y1, int x2, int y2){
	return sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}
inline int cerc_cerc(int p1, int p2){
	double a = dist(v[p1].x1, v[p1].y1, v[p2].x1, v[p2].y1);
	if(a + v[p2].r <= v[p1].r) return 1;
	return 0;
}
inline int cerc_drept(int p1, int p2){
	if(dist(v[p1].x1, v[p1].y1, v[p2].x1, v[p2].y1) > v[p1].r) return 0;
	if(dist(v[p1].x1, v[p1].y1, v[p2].x1, v[p2].y2) > v[p1].r) return 0;
	if(dist(v[p1].x1, v[p1].y1, v[p2].x2, v[p2].y1) > v[p1].r) return 0;
	if(dist(v[p1].x1, v[p1].y1, v[p2].x2, v[p2].y2) > v[p1].r) return 0;
	return 1;
}
inline int drept_cerc(int p1, int p2){
	int ok = 0;
	if(v[p2].x1 - v[p2].r >= v[p1].x1 && v[p2].x1 + v[p2].r <= v[p1].x2) ok++;
	if(v[p2].y1 - v[p2].r >= v[p1].y1 && v[p2].y1 + v[p2].r <= v[p1].y2) ok++;
	if(ok == 2) return 1;
	return 0;
}
inline int drept_drept(int p1, int p2){
	int ok = 0;
	if(v[p1].x1 <= v[p2].x1 && v[p2].x2 <= v[p1].x2) ok++;
	if(v[p1].y1 <= v[p2].y1 && v[p2].y2 <= v[p1].y2) ok++;
	if(ok == 2) return 1;
	return 0;
}
int includ(int p1, int p2){
	if(v[p1].r && v[p2].r) return cerc_cerc(p1, p2);
	if(v[p1].r  && v[p2].r == 0) return cerc_drept(p1, p2);
	if(v[p1].r == 0 && v[p2].r) return drept_cerc(p1, p2);
	return drept_drept(p1, p2);
}
void rezolva(int p){
	for(int i = p - 1; i; --i)
		if(v[i].t != v[p].t && T[v[i].t] >= T[v[p].t] && includ(p, i)){
			T[v[p].t]--;
			v[p].t = v[i].t;
			T[v[p].t]++;
		}
	if(T[v[p].t] > sol) sol = T[v[p].t];
}
int main(){
	freopen("cuiburi.in", "r", stdin);
	freopen("cuiburi.out", "w", stdout);
	scanf("%d", &n);
	for(int i = 1; i <= n; ++i){
		int x;
		scanf("%d", &x);
		if(x){
			scanf("%d%d%d", &v[i].x1, &v[i].y1, &v[i].r);
			v[i].a = (double)v[i].r * v[i].r * pi;
		}
		else {
			scanf("%d%d%d%d", &v[i].x1, &v[i].y1, &v[i].x2, &v[i].y2);
			v[i].a = (v[i].x2-v[i].x1) * (v[i].y2 - v[i].y1);
		}
	}
	sort(v + 1, v + n + 1, comp());
	for(int i = 1; i <= n; ++i){
		v[i].t = i;
		T[i] = 1;
	}
	for(int i = 1; i <= n; ++i)
		rezolva(i);
	printf("%d\n", sol);
	return 0;
}
