#include <stdio.h>
#include <algorithm>
using namespace std;
#define NMAX 510
struct xy{
	int x,y, val;
};
struct compar{
	bool operator()(const xy &a, const xy &b){
		return a.val > b.val;
	}
};
const int lin[6] = {1,-1,0,0};
const int col[6] = {0,0,1,-1};
xy w[NMAX*NMAX];
int P[NMAX][NMAX], Pm[NMAX][NMAX];
int viz[NMAX][NMAX];
int q[NMAX*NMAX][3];
int n, MOD, T, nr, p = 1, b;
inline int abs(int x){
	if(x > 0) return x;
	return -x;
}

void solve(int TIMP){
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= n; ++j)
		Pm[i][j] = 0;
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= n; ++j)
			for(int p = 1; p <= n; ++p)
				for(int q = 1; q <= n; ++q)
					if(i != p || j != q)
						Pm[i][j] = max(Pm[i][j], P[p][q] - abs(i-p) - abs(j-q));
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= n; ++j)
			P[i][j] = TIMP + 1 + ( P[i][j] + TIMP * Pm[i][j]) % MOD;
}
inline int dist(int x1, int y1, int x2, int y2){
	return abs(x1-x2) + abs(y1-y2);
}
void relax(int x, int y, int val, int xt, int yt){
	viz[x][y] = 1;
	for(int t = 0; t < 4; ++t){
		int xx = x+lin[t], yy = y+col[t];
		if(P[xx][yy] ==0) continue;
		if(P[xx][yy] - dist(x,y,xx,yy) > Pm[xt][yt])
			Pm[xt][yt] = P[xx][yy] - dist(x, y, xx, yy);
		if(viz[xx][yy]) continue;
		if(Pm[xx][yy] < val) Pm[xx][yy] = val;
		if(P[xx][yy] < val) {
			q[++b][0] = xx;
			q[b][1] = yy;
			q[b][2] = val;
		}
	}
}
void df(int x, int y){
	q[++b][0] = x;
	q[b][1] = y;
	q[b][2] = P[x][y]-1;
	for(int i = 1; i <= b; ++i)
		relax(q[i][0], q[i][1], q[i][2]-1, x, y);
}
void solve2(int TIMP){
	sort(w + 1, w + nr + 1, compar());
	for(int i = 1; i <= nr; ++i)
		if(Pm[w[i].x][w[i].y] <= P[w[i].x][w[i].y]) 
			df(w[i].x, w[i].y);
}
int main(){
	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);
	scanf("%d%d%d", &n, &T, &MOD);
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= n; ++j){
			scanf("%d", &P[i][j]);
			w[++nr].x = i; 
			w[nr].y = j;
			w[nr].val = P[i][j];
		}
	for(int i = 1; i <= T; ++i)
		if(n <= 40) solve(i);
		else 
			solve2(i);
	int s = 0;
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= n; ++j)
			s = (s + P[i][j]) %MOD;
	printf("%d\n", s);
	return 0;
}
