#include <cstdio>
#include <algorithm>
#include <vector>
#define MAXN 2100
using namespace std;
struct cuib{
	char T;
	int p1,p2,p3,p4,gr;
} v[MAXN],NV[MAXN];
int N,N2;
vector<int> G[MAXN];
int viz[MAXN];
int stiva[MAXN],VF;
int dyn[MAXN];


void DFS(int nod){

	viz[nod]=1;
	for (vector<int>::iterator it=G[nod].begin();it!=G[nod].end();++it)
		if (viz[*it]==0) DFS(*it);

	++VF;
	stiva[VF]=nod;
}


inline bool cmp(const cuib &A, const cuib &B){

	if (A.T!=B.T) return (A.T<B.T);
	if (A.p1!=B.p1) return (A.p1<B.p1);
	if (A.p2!=B.p2) return (A.p2<B.p2);
	if (A.p3!=B.p3) return (A.p3<B.p3);
	return (A.p4<B.p4);
}


int square_dist(int x1,int y1,int x2,int y2){

	return ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

int cuibareste(cuib A,cuib B){
	if (A.T==B.T){

		if (A.T==0){
			if (A.p1<=B.p1 && A.p2<=B.p2 && B.p3<=A.p3 && B.p4<=A.p4) return 1; else return 0;
		}
		
		if (A.p3<B.p3) return 0;

		int sqd=square_dist(A.p1,A.p2,B.p1,B.p2);

		int cmpr=(A.p3-B.p3);
		cmpr=cmpr*cmpr;

		if (cmpr>=sqd) return 1; else return 0;
	} else if (A.T==0){

		if (B.p1<A.p1 || B.p1>A.p3 || B.p2<A.p2 || B.p2>A.p4) return 0;
		int dmin=B.p1-A.p1;
		if ((A.p3-B.p1)<dmin) dmin=A.p3-B.p1;
		if ((B.p2-A.p2)<dmin) dmin=B.p2-A.p2;
		if ((A.p4-B.p2)<dmin) dmin=A.p4-B.p2;

		if (dmin<B.p3) return 0; else return 1;
	}

	int R2=A.p3*A.p3;

	int sqd=square_dist(A.p1,A.p2,B.p1,B.p2);
	if (sqd>R2) return 0;
	sqd=square_dist(A.p1,A.p2,B.p1,B.p4);
	if (sqd>R2) return 0;
	sqd=square_dist(A.p1,A.p2,B.p3,B.p4);
	if (sqd>R2) return 0;
	sqd=square_dist(A.p1,A.p2,A.p3,A.p2);
	if (sqd>R2) return 0;

	return 1;
}




int main(){

	freopen("cuiburi.in","r",stdin);
	freopen("cuiburi.out","w",stdout);

	scanf("%d",&N);

	for (int i=1;i<=N;++i){
		int tip;
		scanf("%d",&tip);
		v[i].T=tip;
		if (tip==0)
			scanf("%d%d%d%d",&v[i].p1,&v[i].p2,&v[i].p3,&v[i].p4);
		else {
			scanf("%d%d%d",&v[i].p1,&v[i].p2,&v[i].p3);
			v[i].p4=0;
		}
		v[i].gr=1;
	}


	fclose(stdin);
	
	sort(v+1,v+N+1,cmp);
	
	N2=1;

	NV[N2]=v[1];

	for (int i=2;i<=N;++i)
		if (v[i].T==NV[N2].T && v[i].p1==NV[N2].p1 && v[i].p2==NV[N2].p2 && v[i].p3==NV[N2].p3 && v[i].p4==NV[N2].p4)
			NV[N2].gr++; else NV[++N2]=v[i];

	for (int i=1;i<=N2;++i)
		for (int j=1;j<=N2;++j)
			if (i!=j) if (cuibareste(NV[i],NV[j]))  G[i].push_back(j);
	
	memset(viz,0,sizeof(viz));

	VF=0;
	for (int i=1;i<=N2;++i)
		 if (viz[i]==0) DFS(i);

	int maxdyn=0;
	for (int i=1;i<=VF;++i){
		int nod=stiva[i];
		dyn[nod]=NV[nod].gr;
		int maxother=0;
		for (vector<int>::iterator it=G[nod].begin();it!=G[nod].end();++it)
			if (dyn[*it]>maxother) maxother=dyn[*it];

		dyn[nod]+=maxother;
		if (dyn[nod]>maxdyn) maxdyn=dyn[nod];
	}

	printf("%d\n",maxdyn);

	fclose(stdout);

	return 0;
}
