#include <fstream>
#include <algorithm>
#include <math.h>
#define IN "cuiburi.in"
#define OUT "cuiburi.out"
#define N 2005
#define eps 0.000001

using namespace std;

ifstream fin (IN);
ofstream fout (OUT);

struct pct
{
    double a, b, c, d;
}A[N];

struct coord
{
    double x,y;
};

int fel[N], tati[N];
int n, t;
double Aria[N];
int cati[N];
int viz[N];
int niv[N];
int Q[N];
int inc=0,sf;
int Rez;

struct nod
{
    int inf;
    nod *next;
}*V[N];

void add(nod *&a, int i)
{
    nod *q=new nod;
    q->inf=i;
    q->next=a;
    a=q;
}

void citire()
{
    fin>>n;
    for (int i=1;i<=n;i++)
    {
        fin>>fel[i];
        if (fel[i]==0)
        {
            fin>>A[i].a>>A[i].b>>A[i].c>>A[i].d;
            Aria[i]=(A[i].c-A[i].a)*(A[i].d-A[i].b);
        }
        else
            fin>>A[i].a>>A[i].b>>A[i].c;

        tati[i]=i;
        cati[i]=1;
    }
}

double dist(int i,int j)
{
    return sqrt((A[i].a -A[j].a)*(A[i].a -A[j].a) + (A[i].b-A[j].b)*(A[i].b-A[j].b));
}


double seg(coord A, coord B)
{
    return sqrt((A.x-B.x)*(A.x-B.x) + (A.y-B.y)*(A.y-B.y));
}

double herr(coord A, coord B, coord C)
{
    double P=(seg(A, B)+ seg(A, C)+ seg(B, C))/2;
    return sqrt( P * (P-seg(A, B)) * (P-seg(A, C)) * (P-seg(B, C)) );
}


double Ar(double Px,double Py, int Poz)
{
    //calculez ariua unui patrat cu un pct in interior/exterior
    coord A1, B, C, D, Punct;
    Punct.x=Px;
    Punct.y=Py;
    A1.x=A[Poz].a;
    A1.y=A[Poz].d;
    B.x=A[Poz].a;
    B.y=A[Poz].b;
    C.x=A[Poz].c;
    C.y=A[Poz].b;
    D.x=A[Poz].c;
    D.y=A[Poz].d;
    return herr(Punct, A1, B) + herr(A1, Punct, D) + herr(D, Punct, C) +herr(C, Punct, B);
}

double Segment(double x,double y,double x1,double y1)
{
    return sqrt((x-x1)*(x-x1) + (y-y1)*(y-y1));
}

int ok(double x,double y, int P)
{
    if (x<A[P].a || x>A[P].c)
        return 0;
    if (y<A[P].b || y>A[P].d)
        return 0;
    return 1;
}

int da(int p1, int p2)
{
    if (fel[p1]==1 && fel[p2]==1)
    {
        if (dist(p1,p2) - (A[p1].c + A[p2].c) < eps)
            return 1;
        return 0;
    }

    if (fel[p1]==0 && fel[p2]==0)
    {
        if (ok(A[p1].a, A[p1].d, p2) && fabs(Ar(A[p1].a, A[p1].d, p2) - Aria[p2] )< eps)
            return 1;

        if (ok(A[p1].a, A[p1].b, p2) && fabs(Ar(A[p1].a, A[p1].b, p2) - Aria[p2] )< eps)
            return 1;

        if (ok(A[p1].c, A[p1].b, p2) && fabs(Ar(A[p1].c, A[p1].b, p2) -Aria[p2] )< eps)
            return 1;

        if (ok(A[p1].c, A[p1].d, p2) && fabs(Ar(A[p1].c, A[p1].d, p2) - Aria[p2] )< eps)
            return 1;


        // invers
        if (ok(A[p2].a, A[p2].d, p1) && fabs(Ar(A[p2].a, A[p2].d, p1) - Aria[p1] )< eps)
            return 1;

        if (ok(A[p2].a, A[p2].b, p1) && fabs(Ar(A[p2].a, A[p2].b, p1)- Aria[p1] )< eps)
            return 1;

        if (ok(A[p2].c, A[p2].b, p1) && fabs(Ar(A[p2].c, A[p2].b, p1) -Aria[p1] )< eps)
            return 1;

        if (ok(A[p2].c, A[p2].d, p1) && fabs(Ar(A[p2].c, A[p2].d, p1) - Aria[p1] )< eps)
            return 1;

        return 0;
    }

    if (fel[p2]==1)
    {
        int aux=p1;
        p1=p2;
        p2=aux;
    }

    if (ok(A[p1].a, A[p1].b, p2) && fabs(Ar(A[p1].a, A[p1].b, p2)- Aria[p2] )< eps )
        return 1;

    if (A[p1].c - Segment(A[p1].a,  A[p1].b, A[p2].a, A[p2].b)>=-eps)
        return 1;

    if (A[p1].c - Segment(A[p1].a,  A[p1].b, A[p2].c, A[p2].b)>=-eps)
        return 1;

    if (A[p1].c - Segment(A[p1].a,  A[p1].b, A[p2].c, A[p2].d)>=-eps)
        return 1;

    if (A[p1].c - Segment(A[p1].a,  A[p1].b, A[p2].a, A[p2].d)>=-eps)
        return 1;

    if (A[p1].a >= A[p2].a && A[p1].a <= A[p2].c)
    {
        if (fabs(A[p1].b - A[p2].b) <= A[p1].c)
            return 1;

        if (fabs(A[p1].b -A[p2].d) <= A[p1].c)
            return 1;
    }

    if (A[p1].b >= A[p2].b && A[p1].b <= A[p2].d)
    {
        if (fabs(A[p1].a -A[p2].a) <= A[p1].c)
            return 1;

        if (fabs(A[p1].a - A[p2].c) <=A[p1].c)
            return 1;
    }
    return 0;
}

void pre_solve()
{
    for (int i=1;i<=n;i++)
        for (int j=i+1;j<=n;j++)
            if (da(i,j))
            {
                add(V[i], j);
                add(V[j], i);
            }
}

int T(int nod)
{
    if (tati[nod]==nod)
        return nod;
    return tati[nod] = T(tati[nod]);
}

void df2(int P)
{
    Q[sf=1]=P;
    viz[P]=1;
    for (int i=1;i<=sf;i++)
        for (nod *j=V[Q[i]];j;j=j->next)
            if (!viz[j->inf])
            {
                viz[j->inf]=1;
                niv[j->inf]=niv[Q[i]]+1;
                Q[sf++]=j->inf;
                if (niv[j->inf]>Rez)
                    Rez=niv[j->inf];
            }
}

void df(int P)
{
    viz[P]=1;
    for (nod *j=V[P];j;j=j->next)
    {
        if (!viz[j->inf])
        {
            viz[j->inf]=1;
            niv[j->inf]=niv[P]+1;
            if (Rez<niv[j->inf])
                Rez=niv[j->inf];
            df(j->inf);
        }
    }
}

void solve()
{
    for (int i=1;i<=n;i++)
    {
        for (int j=1;j<=n;j++)
        {
            viz[j]=0;
            niv[j]=0;
        }
        niv[i]=1;
        viz[i]=1;
        df(i);
    }
    if (Rez!=0)
        fout<<Rez-1<<"\n";
    else
        fout<<0<<"\n";
}

int main ()
{
    citire();
    pre_solve();
    solve();
    return 0;
}
