#include <cstdio>
#include <cstring>
#include <algorithm>

#define maxN 510
#define inf 200000000

#define x first
#define y second
#define mp make_pair

using namespace std;

int n, t, q;
int i, j, k;
int P[maxN][maxN], lft_up[maxN][maxN], rgt_up[maxN][maxN], lft_dn[maxN][maxN], rgt_dn[maxN][maxN];
pair <int, int> lu[maxN][maxN], ru[maxN][maxN], ld[maxN][maxN], rd[maxN][maxN];
pair <int, int> vlu[maxN], vru[maxN], vld[maxN], vrd[maxN];
int curr_lu[maxN], curr_ru[maxN], curr_ld[maxN], curr_rd[maxN];
int pMax[maxN][maxN];
int sol;

inline void baga_partiale() {
	int i, j; 

	for (i = 1; i <= n; i++)
		for (j = 1; j <= n; j++) {
			if (lft_up[i - 1][j] > lft_up[i][j]) {
				lft_up[i][j] = lft_up[i - 1][j];
				lu[i][j] = lu[i - 1][j];
			}
			else 
				lu[i][j] = mp(i, j);
			if (rgt_up[i - 1][j] > rgt_up[i][j]) {
				rgt_up[i][j] = rgt_up[i - 1][j];
				ru[i][j] = ru[i - 1][j];
			}
			else
				ru[i][j] = mp(i, j);
		}

	for (i = n; i >= 1; i--) 
		for (j = 1; j <= n; j++) {
			if (lft_dn[i + 1][j] > lft_dn[i][j]) {
				lft_dn[i][j] = lft_dn[i + 1][j];
				ld[i][j] = ld[i + 1][j];
			}
			else
				ld[i][j] = mp(i, j);

			if (rgt_dn[i + 1][j] > rgt_dn[i][j]) {
				rgt_dn[i][j] = rgt_dn[i + 1][j];
				rd[i][j] = rd[i + 1][j];
			}
		}

}

inline void baga_memset() {
	int i, j;
/*	for (i = 0; i < n + 5; i++)
		for (j = 0; j < n + 5; j++) {
			lft_up[i][j] = lft_dn[i][j] = rgt_up[i][j] = rgt_dn[i][j] = -inf;
		}*/

	for (i = 0; i <= n + 2; i++) {
		lft_up[0][i] = lft_up[n + 1][i] = lft_up[i][0] = lft_up[i][n + 1] = -inf;
		lft_dn[0][i] = lft_dn[n + 1][i] = lft_dn[i][0] = lft_dn[i][n + 1] = -inf;
		rgt_up[0][i] = rgt_up[n + 1][i] = rgt_up[i][0] = rgt_up[i][n + 1] = -inf;
		rgt_dn[0][i] = rgt_dn[n + 1][i] = rgt_dn[i][0] = rgt_dn[i][n + 1] = -inf;
	}
}


inline int dist(int a, int b, int x, int y) {
	return (abs(a - x) + abs(b - y));
}	

inline void check(pair <int, int> pozitie) {
	int p, q;
	p = pozitie.x; q = pozitie.y;

	if ((P[p][q] - dist(p, q, i, j)) > pMax[i][j])
		pMax[i][j] = P[p][q] - dist(p, q, i, j);
}

int main() {
	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);

	scanf("%d%d%d", &n, &t, &q);

	for (i = 1; i <= n; i++)
		for (j = 1; j <= n; j++)
			scanf("%d", &P[i][j]);

	for (int z = 1; z <= t; z++) {
		baga_memset();
		for (i = 1; i <= n; i++)
			for (j = 1; j <= n; j++) {
				lft_up[i][j] = P[i][j] - (n - i) - (n - j); //(1,1)->(i,j)
				rgt_up[i][j] = P[i][j] - (n - i) - (j);     //(1, j + 1)->(i, n)
				lft_dn[i][j] = P[i][j] - (i) - (n - j);     //(i + 1, 1) -> (n, j)
				rgt_dn[i][j] = P[i][j] - i - j;    			//(i + 1, j + 1) -> (n, n)
				rd[i][j] = mp(i, j); ru[i][j] = mp(i, j); lu[i][j] = mp(i, j); ld[i][j] = mp(i, j);
			}

		baga_partiale();

		for (i = 1; i <= n; i++) {
			curr_lu[0] = curr_lu[n + 1] = curr_ld[0] = curr_ld[n + 1] = curr_ru[0] = curr_ru[n + 1] = curr_rd[0] = curr_rd[n + 1] = -inf;
			for (j = 1; j <= n; j++) {
				curr_lu[j] = lft_up[i][j]; curr_ru[j] = rgt_up[i][j];
				curr_ld[j] = lft_dn[i][j]; curr_rd[j] = rgt_dn[i][j];
			}

			for (j = 1; j <= n; j++) {
				if (curr_lu[j] < curr_lu[j - 1]) {
					curr_lu[j] = curr_lu[j - 1];
					vlu[j] = vlu[j - 1];
				}
				else
					vlu[j] = lu[i][j];

				if (curr_ld[j] < curr_ld[j - 1]) {
					curr_ld[j] = curr_ld[j - 1];
					vld[j] = vld[j - 1];
				}
				else
					vld[j] = ld[i][j];
			}

			for (j = n; j >= 1; j--) {
				if (curr_ru[j] < curr_ru[j + 1]) {
					curr_ru[j] = curr_ru[j + 1];
					vru[j] = vru[j + 1];
				}
				else
					vru[j] = ru[i][j];

				if (curr_rd[j] < curr_rd[j + 1]) {
					curr_rd[j] = curr_rd[j + 1];
					vrd[j] = vrd[j + 1];
				}
				else
					vrd[j] = rd[i][j];
			}
				

			for (j = 1; j <= n; j++) {
				pMax[i][j] = -inf;
				check(vlu[j - 1]);
				check(vru[j + 1]);
				check(vld[j - 1]);
				check(vrd[j + 1]);
				check(lu[i - 1][j]);
				check(ld[i + 1][j]);
			}

		
		}

		for (i = 1; i <= n; i++) {
			for (j = 1; j <= n; j++) {
				P[i][j] = z + 1 + ((P[i][j] + z * pMax[i][j]) % q);
			}
		}

	}

	for (i = 1; i <= n; i++)
		for (j = 1; j <= n; j++)
			sol = (sol + P[i][j]) % q;

	printf("%d\n", sol);

	return 0;
}
