// O(N * HMAX^2)

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#define ANM 100005
#define NM 1505
#define HM 1505
#define PB push_back
#define MKP make_pair
#define LL long long
#define infl 2000000000000000LL

vector <pair<int,pair<int,int> > > G[ANM];
vector <int> ARB[ANM];

int N, FAT[NM], D[NM], C[NM], H[NM], HMAX, CM;
int cd[NM];

char viz[NM];

LL S[NM][HM];

void parc (int nod)
{
	viz[nod] = 1;
	
	for (int i = 0; i < (int) G[nod]. size(); ++i)
	{
		int nnod = G[nod][i].first;
		int d = G[nod][i].second.first;
		int c = G[nod][i].second.second;
		
		if (viz[nnod]) continue;

		FAT[nnod] = nod;
		D[nnod] = d;
		C[nnod] = c;
		ARB[nod].PB(nnod);

		parc (nnod);

		H[nod] = max(H[nod], H[nnod] + D[nnod]);	
	}	
}

void baga_easy()
{
	for (int i = 0; i <= N; ++i)
		for (int j = 0; j <= HMAX; ++j)
			S[i][j] = infl;
		
	for	(int i = 1; i <= N; ++i)
		if (ARB[i].empty()) S[i][0] = 0;
	
	for (int i = N; i >= 2; --i)
	{
		int nod = cd[i];
		
		for (int h1 = H[FAT[nod]]; h1 <= HMAX; ++h1)
		{	
			LL bst = infl;
			
			for (int h2 = D[nod]; h1 - h2 >= H[nod]; ++h2)
			{
				LL ad = (LL)(h2 - D[nod]) * (LL)C[nod];
				
				bst = min(bst, S[nod][h1 - h2] + ad);
			}	
			
			if (S[FAT[nod]][h1] >= infl) S[FAT[nod]][h1] = bst;
			else S[FAT[nod]][h1] += bst;
		}			
	}	
	
	LL bst = infl;
	
	/*
	for (int i = 1; i <= N; ++i)
	{
		for (int j = 0; j <= HMAX; ++j)
			if (S[i][j] >= infl) printf("- ");
			else printf("%lld ", S[i][j]);
		
		printf("\n");
	}
	*/
	
	for (int h = 0; h <= HMAX; ++h)
		bst = min (bst, S[1][h]);
	
	printf ("%lld", bst);		
}

void solve()
{
	parc (1);
	
	HMAX = H[1];
	
	memset (viz, 0, sizeof(viz));
	
	cd[++cd[0]] = 1;
	
	for (int i = 1; i <= cd[0]; ++i)
	{
		int nod = cd[i];

		for (int j = 0; j < (int) ARB[nod].size(); ++j)
		{
			int nnod = ARB[nod][j];
			
			cd[++cd[0]] = nnod;
		}		
	}	
	
	baga_easy();
}

int main()
{
	int a, b, c, d;
	
	freopen ("arb.in", "r", stdin);
	freopen ("arb.out", "w", stdout);
	
	scanf ("%d", &N);
	
	for (int i = 1; i < N; ++i)
	{
		scanf ("%d %d %d %d", &a, &b, &d, &c);
		
		G[a].PB(MKP(b, MKP(d,c)));
		G[b].PB(MKP(a, MKP(d,c)));
		
		CM = max(CM, c);
	}	
	
	if (N <= 3 || (int)G[1].size() == N-1)
	{
		if ((int) G[1].size() == 1)
		{
			printf ("0");
			return 0;
		}	
		
		int dm = 0;
		
		for (int i = 0; i < (int)G[1].size(); ++i)
		{
			int dc = G[1][i].second.first;
			
			dm = max(dm, dc);
		}	
		
		LL ansc = 0;
		
		for (int i = 0; i < (int)G[1].size(); ++i)
		{
			int dc = G[1][i].second.first;
			int cc = G[1][i].second.second;
			
			ansc += (LL)(dm - dc) * (LL)cc; 
		}	
		
		printf ("%lld", ansc);
		return 0;
	}		
	
	solve();
	
	return 0;
}