#include <iostream>
#include <string>

using namespace std;

#define NM 505
#define inf 1000000

int N, T, Q;

int P[NM][NM], PA[NM][NM];

inline int ab(int nr)
{
	if (nr >= 0) return nr;
	return -nr;
}

inline int dist (int i,int j, int ii, int jj)
{
	return ab(i-ii) + ab(j-jj);
}

void bagaTN4()
{
	for (int t = 1; t <= T; ++t)
	{
		for (int i = 1; i <= N; ++i)
			for (int j = 1 ; j <= N; ++j)
				PA[i][j] = -inf;
		
		for (int i = 1; i <= N; ++i)
			for (int j = 1 ; j <= N; ++j)
				for (int ii = 1; ii <= N; ++ii)
					for (int jj = 1; jj <= N; ++jj)
					{
						if (ii == i && jj == j) continue;
						
						PA[ii][jj] = max(PA[ii][jj], P[i][j] - dist (i,j,ii,jj) );
					}
		
		for (int i = 1; i <= N; ++i)
			for (int j = 1; j <= N; ++j)
			{	
				P[i][j] = (P[i][j] + t * PA[i][j]) % Q;
				P[i][j] += (t + 1);	
			}	
	}	
	
	int ans = 0;
	
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= N; ++j)
			ans =(ans + P[i][j]) % Q;
			
	
	printf ("%d", ans);		
}

int main()
{
	freopen ("v2d.in", "r", stdin);
	freopen ("v2d.out", "w", stdout);
	
	scanf ("%d %d %d", &N, &T, &Q);
	
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= N; ++j)
			scanf ("%d", &P[i][j]);
	
	bagaTN4(); 		
	
	return 0;
}