#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#define maxN 	512

using namespace std;

int arb_st[1024], arb_dr[1024], C[maxN][maxN], V[maxN][maxN], N, st[maxN], dr[maxN], Q, C_st[maxN][maxN], C_dr[maxN][maxN];

void get_inline (int line) {
    int i, x1, x2;

    for (i = 1; i <= N; ++ i)
        C_st[line][i] = max(C_st[line][i], max(C_st[line][i - 1] - 1, V[line][i - 1] - 1));
    for (i = N; i; -- i)
        C_dr[line][i] = max(C_dr[line][i], max(C_dr[line][i + 1] - 1, V[line][i + 1] - 1));

    for (i = 1; i <= N; ++ i) {
        x1 = (i > 0) ? (C_st[line][i - 1] - 1) : 0;
        x2 = (i < N) ? (C_dr[line][i + 1] - 1) : 0;
        C[line][i] = max(C[line][i], max(x1, x2));
    }
}

void baga_marfa (int z) {
	int i, j;

//    fprintf(stderr, "Ziua %d\n", z);
	
	memset(arb_st, 0, sizeof(arb_st));
	memset(arb_dr, 0, sizeof(arb_dr));
	memset(C_st, 0, sizeof(C_st));
    memset(C_dr, 0, sizeof(C_dr));
    memset(C, 0, sizeof(C));

    for (i = 1; i <= N; ++ i) {
        get_inline(i);

        for (j = 1; j <= N; ++ j) {
            C_st[i][j] = max(max(C_st[i - 1][j] - 1, V[i - 1][j] - 1), C_st[i][j]);
            C_dr[i][j] = max(max(C_dr[i - 1][j] - 1, V[i - 1][j] - 1), C_dr[i][j]);
            C[i][j] = max(C[i][j], max(C_st[i][j], C_dr[i][j]));
        }
    }

	memset(C_st, 0, sizeof(C_st));
    memset(C_dr, 0, sizeof(C_dr));

    for (i = N; i; -- i) {
        get_inline(i);
        for (j = 1; j <= N; ++ j) {
            C_st[i][j] = max(max(C_st[i + 1][j] - 1, V[i + 1][j] - 1), C_st[i][j]);
            C_dr[i][j] = max(max(C_dr[i + 1][j] - 1, V[i + 1][j] - 1), C_dr[i][j]);
            C[i][j] = max(C[i][j], max(C_st[i][j], C_dr[i][j]));
        }
    }

    for (i = 1; i <= N; ++ i)
        for (j = 1; j <= N; ++ j)
            V[i][j] = z + 1 + ((V[i][j] + z * C[i][j]) % Q);

}

int main () {
	int T, i, j, Sol = 0;
	
	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);
	
	scanf("%d%d%d", &N, &T, &Q);
	
	for (i = 1; i <= N; ++ i)
		for (j = 1; j <= N; ++ j)
			scanf("%d", &V[i][j]);
			
	for (i = 1; i <= T; ++ i)
		baga_marfa(i);
		
    for (i = 1; i <= N; ++ i)
        for (j = 1; j <= N; ++ j)
            Sol = (Sol + V[i][j]) % Q;

    printf("%d\n", Sol);
}
