#include <algorithm>
#include <stdio.h>
#include <vector>

#define MAX 100010
#define ll long long
#define pb push_back

using namespace std;

class edge
{
public:
	int fiu, dist, cost;

	edge()
	{
	}

	edge(int f, int d, int c)
	{
		this->fiu = f, this->dist = d, this->cost = c;
	}
};
int n, maxAlt;
bool sel[MAX];
int et[MAX], sub[MAX];
ll costUnit[MAX], costTot[MAX];
vector <edge> vctDrum[MAX], vctFii[MAX];

inline void dfs(int nod, int l)
{
	sel[nod] = 1;
	et[nod] = l;
	maxAlt = max(maxAlt, l);

	int maxSub = 0;
	for (int i = 0; i < vctDrum[nod].size(); i++)
		if (!sel[vctDrum[nod][i].fiu])
		{
			vctFii[nod].pb(vctDrum[nod][i]);

			dfs(vctDrum[nod][i].fiu, l + vctDrum[nod][i].dist);
			maxSub = max(maxSub, sub[vctDrum[nod][i].fiu] + vctDrum[nod][i].dist);
		}
	sub[nod] = maxSub;
}

inline void solve(int nod, ll cost)
{
	ll elast = maxAlt - et[nod] - sub[nod], costFii = 0, costProb = 0;

	if (!(vctFii[nod].size()))
	{
		costTot[nod] = elast * cost;
		costUnit[nod] = cost;

		return;
	}

	for (int i = 0; i < vctFii[nod].size(); i++)
	{
		solve(vctFii[nod][i].fiu, vctFii[nod][i].cost);

		costFii += costUnit[vctFii[nod][i].fiu];
		costProb += costTot[vctFii[nod][i].fiu];
	}

	if (cost < costFii)
		costTot[nod] = costProb - elast * costFii + elast * cost;
	else costTot[nod] = costProb;

	costUnit[nod] = min(cost, costFii);
}

int main()
{
	freopen("arb.in", "r", stdin);
	freopen("arb.out", "w", stdout);

	scanf("%d", &n);

	for (int i = 1; i < n; i++)
	{
		int n1, n2, d, c;
		scanf("%d %d %d %d", &n1, &n2, &d, &c);

		vctDrum[n1].pb(edge(n2, d, c));
		vctDrum[n2].pb(edge(n1, d, c));
	}

	dfs(1, 0);

	ll s = 0;
	for (int i = 0; i < vctFii[1].size(); i++)
	{
		solve(vctFii[1][i].fiu, (ll) vctFii[1][i].cost);

		s += costTot[vctFii[1][i].fiu];
	}

	printf("%lld\n", s);

	fclose(stdin);
	fclose(stdout);
	return 0;
}
