#include <algorithm>
#include <stdio.h>

#define MAX 512
#define mp make_pair
#define f first
#define s second

using namespace std;

int dirI[] = {-1, 0, 0, 1};
int dirJ[] = {0, -1, 1, 0};
int n, t, q, dimHeap, sum;
pair <int, pair <int, int> > maxHeap[MAX * MAX];
int pa[MAX][MAX], pmax[MAX][MAX], loc[MAX][MAX], sel[MAX][MAX];

inline void heapUp(int nod)
{
	if (nod == 1)
		return;

	if (maxHeap[nod].f > maxHeap[nod / 2].f)
	{
		swap(maxHeap[nod], maxHeap[nod / 2]);
		swap(loc[maxHeap[nod].s.f][maxHeap[nod].s.s], loc[maxHeap[nod / 2].s.f][maxHeap[nod / 2].s.s]);

		heapUp(nod / 2);
	}
}

inline void heapDown(int nod)
{
	if (2 * nod <= dimHeap)
	{
		int pos = 2 * nod;
		if (2 * nod < dimHeap && maxHeap[pos].f < maxHeap[pos + 1].f)
			pos++;

		if (maxHeap[nod].f < maxHeap[pos].f)
		{
			swap(maxHeap[nod], maxHeap[pos]);
			swap(loc[maxHeap[nod].s.f][maxHeap[nod].s.s], loc[maxHeap[pos].s.f][maxHeap[pos].s.s]);

			heapDown(pos);
		}
	}
}

int main()
{
	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);

	scanf("%d %d %d", &n, &t, &q);

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			scanf("%d", &pa[i][j]);

	for (int z = 1; t; z++, t--)
	{
		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
				sel[i][j] = 0;
		dimHeap = 0;
		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
			{
				pmax[i][j] = pa[i][j];

				maxHeap[++dimHeap] = mp(pa[i][j], mp(i, j));
				loc[i][j] = dimHeap;
				heapUp(dimHeap);
			}

		for (int i = 1; i <= n * n; i++)
		{
			pair <int, int> act = maxHeap[1].s;

			maxHeap[1] = maxHeap[dimHeap];
			loc[maxHeap[1].s.f][maxHeap[1].s.s] = 1;
			dimHeap--;
			heapDown(1);

			for (int dir = 0; dir < 4; dir++)
			{
				int x = act.f + dirI[dir], y = act.s + dirJ[dir];
				if ((pmax[x][y] <= pmax[act.f][act.s] - 1) && (1 <= x && x <= n && 1 <= y && y <= n))
				{
					pmax[x][y] = pmax[act.f][act.s] - 1;
					sel[x][y] = 1;

					maxHeap[loc[x][y]].f = pmax[act.f][act.s] - 1;
					heapUp(loc[x][y]);
				}
			}
		}

		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
				if (!sel[i][j])
				{
					pmax[i][j] = -LONG_MAX;

					for (int ii = 1; ii <= n; ii++)
						for (int jj = 1; jj <= n; jj++)
							if (i != ii || j != jj)
								pmax[i][j] = max(pmax[i][j], pa[ii][jj] - abs(i - ii) - abs(j - jj));
				}
		
		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
				pa[i][j] = 1 + z + (pa[i][j] + z * pmax[i][j]) % q;
	}

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			sum = (sum + pa[i][j]) % q;

	printf("%d\n", sum);

	fclose(stdin);
	fclose(stdout);
	return 0;
}
