#include <stdio.h>
#include <fstream.h>
#include <math.h>
#define Nmax 505
#define InFile "v2d.in"
#define OutFile "v2d.out"

int n, T, Q, sum;
int P[Nmax][Nmax], Pm[Nmax][Nmax];

void citire();
void determinare();
int dist (int, int, int, int);
int max (int, int);
void afisare();

int main()
{
  citire();
  determinare();
  afisare();
  return 0;
}

void citire()
{
  int i, j;
  FILE *fin=fopen (InFile, "r");
  fscanf (fin, "%d %d %d\n", &n, &T, &Q);
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      fscanf (fin, "%d ", &P[i][j]);
}

void determinare()
{
  int z, i, j;
  for (z=1; z<=T; z++) // ptr fiecare zi
  {
    //ptr fiecare vrajitor
    for (i=0; i<n; i++)
      for (j=0; j<n; j++)
        Pm[i][j]=max (i, j);
    for (i=0; i<n; i++)
      for (j=0; j<n; j++)
        P[i][j]=z+1+((P[i][j]+z*Pm[i][j])%Q);
  }
  sum=0;
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      sum=(sum%Q+P[i][j]%Q)%Q;
}

int dist (int a, int b, int a1, int b1)
{
  return abs(a-a1)+abs(b-b1);
}

int max (int x, int y)
{
  int val, mx=0;
  int i, j;
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      if (i!=x||j!=y)
      {
        val=P[i][j]-dist (i, j, x, y);
        if (val>mx)
          mx=val;
      }
  return mx;
}

void afisare()
{
  FILE *fout=fopen (OutFile, "w");
  fprintf (fout, "%d\n", sum);
  fclose (fout);
}
