#include <cstdio>
#include <vector>

using namespace std;

#define MAXN 100005
#define muc pair<int, pair<int, int> >
#define nod first
#define dst second.first
#define cst second.second
#define make_muc(nod, dst, cst) make_pair(nod, make_pair(dst, cst))
#define LL long long

int N, cstDown[MAXN], maxDown[MAXN];
vector<muc> con[MAXN];

inline void dfs(int k, int p=0) {
    vector<muc> :: iterator it;
    int sumDownCon = 0, leaf = 1;
    maxDown[k] = 0;
    for (it = con[k].begin(); it != con[k].end(); it++) {
        if (it->nod == p) {
            cstDown[k] = it->cst;
            continue;
        }
        leaf = 0;
        dfs(it->nod, k);
        sumDownCon += cstDown[it->nod];
        maxDown[k] = max(maxDown[k], maxDown[it->nod] + it->dst);
    }
    if (!leaf && sumDownCon < cstDown[k]) {
        cstDown[k] = sumDownCon;
    }
}

LL SUM = 0;
inline void solve(int k, int p, int needed) {
    vector<muc> :: iterator it;
    SUM += ((LL)needed - maxDown[k]) * cstDown[k];
    for (it = con[k].begin(); it != con[k].end(); it++) {
        if (it->nod == p) {
            continue;
        }

        solve(it->nod, k, maxDown[k] - it->dst);
    }
}

int main() {
    freopen("arb.in", "rt", stdin);
    freopen("arb.out", "wt", stdout);

    scanf("%d", &N);
    memset(cstDown, 0x3f, sizeof(cstDown));
    for (int i = 0; i < N - 1; i++) {
        int x, y, d, c;
        scanf("%d %d %d %d", &x, &y, &d, &c);
        con[x].push_back(make_muc(y, d, c));
        con[y].push_back(make_muc(x, d, c));
    }

    dfs(1);
    solve(1, 0, maxDown[1]);
    printf("%lld\n", SUM);

    return 0;
}
