#include <cstdio>
#include <algorithm>
#include <deque>

using namespace std;

#define MAXN 505

int N, T, MOD;
int P[MAXN][MAXN], PMaxR[MAXN][MAXN], PMaxD[MAXN][MAXN], PMaxU[MAXN][MAXN];
deque<pair<short, short> > left, right;

inline void addLeft(deque<pair<short, short> > &d, int val, int poz) {
    for (; !d.empty() && d.back().first - poz < val; d.pop_back());
    d.push_back(make_pair(val + poz, poz));
}

inline void addRight(deque<pair<short, short> > &d, int val, int poz) {
    for (; !d.empty() && d.back().first + poz < val; d.pop_back());
    d.push_back(make_pair(val - poz, poz));
}

inline int getMaxLeft(deque<pair<short, short> > &d, int poz) {
    if (d.empty()) {
        return 0;
    }
    return d.front().first - poz;
}

inline int getMaxRight(deque<pair<short, short> > &d, int poz, int limit = -1) {
    if (limit == -1) {
        limit = poz;
    }
    for (; !d.empty() && d.front().second < limit; d.pop_front());
    if (d.empty()) {
        return 0;
    }
    return d.front().first + poz;
}

int main() {
    freopen("v2d.in", "rt", stdin);
    freopen("v2d.out", "wt", stdout);

    scanf("%d %d %d", &N, &T, &MOD);
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            scanf("%d", P[i] + j);
        }
    }

    for (int t = 1; t <= T; t++) {
        for (int i = 0; i < N; i++) {
            left.clear(); right.clear();
            for (int j = 0; j < N; j++) {
                addRight(right, P[i][j], j);
            }

            for (int j = 0; j < N; j++) {
                PMaxR[i][j] = max(getMaxLeft(left, j), getMaxRight(right, j, j + 1));
                addLeft(left, P[i][j], j);
            }

            if (i - 1 >= 0) {
                left.clear(); right.clear();
                for (int j = 0; j < N; j++) {
                    addRight(right, max(PMaxD[i - 1][j], P[i - 1][j]) - 1, j);
                }
                
                for (int j = 0; j < N; j++) {
                    PMaxD[i][j] = max(getMaxLeft(left, j), getMaxRight(right, j));
                    addLeft(left, max(PMaxD[i - 1][j], P[i - 1][j]) - 1, j);
                }
            } else {
                for (int j = 0; j < N; j++) {
                    PMaxD[i][j] = 0;
                }
            }
        }

        for (int i = N - 1; i >= 0; i--) {
            if (i + 1 < N) {
                left.clear(); right.clear();
                for (int j = 0; j < N; j++) {
                    addRight(right, max(PMaxU[i + 1][j], P[i + 1][j]) - 1, j);
                }
                
                for (int j = 0; j < N; j++) {
                    PMaxU[i][j] = max(getMaxLeft(left, j), getMaxRight(right, j));
                    addLeft(left, max(PMaxU[i + 1][j], P[i + 1][j]) - 1, j);
                }
            } else {
                for (int j = 0; j < N; j++) {
                    PMaxU[i][j] = 0;
                }
            }
        }

        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                P[i][j] = t + 1 + (P[i][j] + t * max(PMaxR[i][j], max(PMaxD[i][j], PMaxU[i][j]))) % MOD;
            }
        }
    }

    int SUM = 0;
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            SUM = (SUM + P[i][j]) % MOD;
        }
    }
    printf("%d\n", SUM);
    return 0;
}
