#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 512

int PA[NMAX][NMAX];
int EFF[NMAX][NMAX];
int PMAX[NMAX][NMAX];
bool viz[NMAX][NMAX];
bool uz[NMAX][NMAX];
pair<int, int> cd[NMAX * NMAX];
int N, T, Q;

void update_pmax() {
  int i, j;
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      PMAX[i][j] = max(PMAX[i][j], EFF[i][j]);
    }
  }
}

void crossMatrix(int x1, int y1, int x2, int y2, int offsetX, int offsetY) {
  memset(EFF, 0, sizeof(EFF));
  int i, j;
  for (i = x1; i - offsetX != x2; i += offsetX) {
    for (j = y1; j - offsetY != y2; j += offsetY) {
      PMAX[i][j] = max(PMAX[i][j], EFF[i][j]);
      EFF[i + offsetX][j] = max(EFF[i + offsetX][j], max(PA[i][j], EFF[i][j]) - 1);
      EFF[i][j + offsetY] = max(EFF[i][j + offsetY], max(PA[i][j], EFF[i][j]) - 1);
    }
  }
}

void compute(int z) {
  memset(PMAX, 0, sizeof(PMAX));
  int i, j;

  // 1 1
  crossMatrix(1, 1, N, N, 1, 1);
  crossMatrix(1, N, N, 1, 1, -1);
  crossMatrix(N, 1, 1, N, -1, 1);
  crossMatrix(N, N, 1, 1, -1, -1);

  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      PA[i][j] = z + 1 + (PA[i][j] + PMAX[i][j] * z) % Q;
    }
  }
}

int main() {
  freopen("v2d.in", "r", stdin);
  freopen("v2d.out", "w", stdout);

  scanf("%d %d %d ", &N, &T, &Q);

  int i, j;
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      scanf("%d ", &PA[i][j]);
    }
  }

  for (int z = 1; z <= T; z++) {
    compute(z);

/*    printf("PA:\n");
    for (i = 1; i <= N; i++, printf("\n")) {
      for (j = 1; j <= N; j++) {
        printf("%d ", PA[i][j]);
      }
    }
    printf("EFF:\n");
    for (i = 1; i <= N; i++, printf("\n")) {
      for (j = 1; j <= N; j++) {
        printf("%d ", PMAX[i][j]);
      }
    }*/
  }

  int s = 0;
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      s = (s + PA[i][j]);
      while (s >= Q) {
        s = s - Q;
      }
    }
  }

  printf("%d ", s);
  return 0;
}
