#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;

const char iname[] = "arb.in";
const char oname[] = "arb.out";

const int MAX_N = 100005;

typedef long long i64;

vector < pair < int, pair < int, int > > > adj[MAX_N];
vector < int > h(MAX_N);

int get_height(int n) {
    vector < pair < int, pair < int, int > > >::iterator it;

    for (it = adj[n].begin(); it != adj[n].end(); ++ it) {
        get_height(it->first);
        h[n] = max(h[n], h[it->first] + it->second.first);
    }
    return h[n];
}

i64 work(int n) {
    vector < pair < int, pair < int, int > > >::iterator it;
    i64 ans = 0;

    for (it = adj[n].begin(); it != adj[n].end(); ++ it) {
        ans += ((i64) ((h[n] - it->second.first) - h[it->first])) * it->second.second;
        ans += work(it->first);
    }
    return ans;
}

int main(void) {
    FILE *fi = fopen(iname, "r");
    FILE *fo = fopen(oname, "w");
    int n;

    assert(fscanf(fi, "%d", &n) == 1);
    assert(1 <= n && n <= 100000);
    for (int i = 1; i < n; ++ i) {
        int x, y, d, c;
        assert(fscanf(fi, "%d %d %d %d", &x, &y, &d, &c) == 4);
        assert(1 <= x && x <= n);
        assert(1 <= y && y <= n);
        assert(1 <= d && d <= 10000);
        assert(1 <= c && c <= 10000);
        assert(x != y);
        adj[x].push_back(make_pair(y, make_pair(d, c)));
    }
    get_height(1);
    fprintf(fopen(oname, "w"), "%lld\n", work(1));

    fclose(fi), fclose(fo);
    return 0;
}
