#include <fstream>
#include <cstring>
#include <queue>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int MAXN = 510;
const int MAXQ = 30110;
const int MAXX = 250010;
const int MAXD = 4;
const int dirx[MAXD] = {-1, 0, 1, 0};
const int diry[MAXD] = {0, -1, 0, 1};

#define ff first
#define ss second

int N, T, Q;
int P[MAXN][MAXN], Pmax[MAXN][MAXN];
int from[MAXN][MAXN];
int cnt[MAXQ];
pair <int, pair <int, int> > v[MAXX];
queue < pair <int, pair <int, int> > > q;

void calcNewMatrix(int d) {
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= N; ++j)
			P[i][j] = 1 + d + (P[i][j] + d * Pmax[i][j]) % Q;
}

int cmp(pair <int, pair <int, int> > x, pair <int, pair <int, int> > y) {
	return x.first > y.first;
}

void sortValues() {
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= N; ++j) 
			v[(i-1)*N+j] = make_pair(P[i][j], make_pair(i, j));

	sort(v+1, v+N*N+1, cmp);
}

int dist(int x1, int y1, int x2, int y2) {
	return abs(x1-x2) + abs(y1-y2);
}

void calcDistances() {
	sortValues();

	memset(from, 0, sizeof(from));
	memset(Pmax, 0, sizeof(Pmax));
	
	int i = 2;
	int val = 1;
	int nr = 1;
	q.push(v[1]);
	from[v[1].ss.ff][v[1].ss.ss] = 1;

	while (!q.empty()) {

		int vfx = q.front().ss.ff;
		int vfy = q.front().ss.ss;
		int cst = q.front().ff;
		q.pop();
		
		for (; i <= N*N && v[i].ff == cst; ++i)
			if (!from[v[i].ss.ff][v[i].ss.ss]) {
				from[v[i].ss.ff][v[i].ss.ss] = i;
				q.push(v[i]);
				++val;
				++nr;
			}

		for (int j = 0; j < MAXD; ++j) {
			int cx = vfx + dirx[j];
			int cy = vfy + diry[j];
			int destx = v[from[vfx][vfy]].ss.ff;
			int desty = v[from[vfx][vfy]].ss.ss;
			int srcx, srcy;

			if (cx > 0 && cy > 0 && cx <= N && cy <= N) {
				if (!from[cx][cy]) {
					from[cx][cy] = from[vfx][vfy];
					Pmax[cx][cy] = cst-1;
					q.push(make_pair(cst-1, make_pair(cx, cy)));
					srcx = cx;
					srcy = cy;
					Pmax[destx][desty] = max(Pmax[destx][desty], P[srcx][srcy] - dist(srcx, srcy, destx, desty));
					++nr;
				} else if (from[cx][cy] != from[vfx][vfy]) {

					srcx = v[from[cx][cy]].ss.ff;
					srcy = v[from[cx][cy]].ss.ss;

					Pmax[destx][desty] = max(Pmax[destx][desty], P[srcx][srcy] - dist(srcx, srcy, destx, desty));
				}
			}
		}
	}
	//printf("Numar de valuri %d\n", val);
}

int calcSum() {
	int res = 0;

	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= N; ++j) {
			res = (res + P[i][j]) % Q;
		}

	return res;
}

int main() {
	
	ifstream fin("v2d.in");
	ofstream fout("v2d.out");

	fin >> N >> T >> Q;

	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= N; ++j)
			fin >> P[i][j];

	for (int i = 1; i <= T; ++i) {
		calcDistances();
		calcNewMatrix(i);
	}

	fout << calcSum() << endl;

	return 0;
}
