// Tiberiu Savin

#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 512

int PA[NMAX][NMAX];
int EFF[NMAX][NMAX];
int PMAX[NMAX][NMAX];
bool viz[NMAX][NMAX];
bool uz[NMAX][NMAX];
pair<int, int> cd[NMAX * NMAX];
int N, T, Q;

void BFS(int start_x, int start_y) {
  int i;
  int sz = 1;

  memset(viz, 0, sizeof(viz));
  memset(uz, 0, sizeof(uz));
  memset(EFF, 0, sizeof(EFF));
  cd[1] = make_pair(start_x, start_y);
  viz[start_x][start_y] = true;
  uz[start_x][start_y] = true;
  for (i = 1; i <= sz; i++) {
    int x = cd[i].first;
    int y = cd[i].second;
    int P = max(EFF[x][y], PA[x][y]) - 1;

    uz[x][y] = true;
//    printf("%d %d %d\n", x, y, P);
    if (x > 1 && EFF[x - 1][y] < P && !uz[x - 1][y]) {
      EFF[x - 1][y] = P;
      if (!viz[x - 1][y]) {
        cd[++sz] = make_pair(x - 1, y);
        viz[x - 1][y] = true;
      }
    }

    if (x < N && EFF[x + 1][y] < P && !uz[x + 1][y]) {
      EFF[x + 1][y] = P;
      if (!viz[x + 1][y]) {
        cd[++sz] = make_pair(x + 1, y);
        viz[x + 1][y] = true;
      }
    }

    if (y < N && EFF[x][y + 1] < P && !uz[x][y + 1]) {
      EFF[x][y + 1] = P;
      if (!viz[x][y + 1]) {
        cd[++sz] = make_pair(x, y + 1);
        viz[x][y + 1] = true;
      }
    }

    if (y > 1 && EFF[x][y - 1] < P && !uz[x][y - 1]) {
      EFF[x][y - 1] = P;
      if (!viz[x][y - 1]) {
        cd[++sz] = make_pair(x, y - 1);
        viz[x][y - 1] = true;
      }
    }
  }
}

void update(int i, int j, int z) {
  PA[i][j] = z + 1 + (PA[i][j] + PMAX[i][j] * z) % Q;
}

void update_pmax() {
  int i, j;
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      PMAX[i][j] = max(PMAX[i][j], EFF[i][j]);
    }
  }
}

void compute(int z) {
  memset(PMAX, 0, sizeof(PMAX));
  int i, j;
  for (i = 1; i <= N; i += N - 1) {
    for (j = 1; j <= N; j += N - 1) {
//      printf("%d %d\n", i, j);
      BFS(i, j);
      update_pmax();
    }
  }
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      update(i, j, z);
    }
  }
}

int main() {
  freopen("v2d.in", "r", stdin);
  freopen("v2d.out", "w", stdout);

  scanf("%d %d %d ", &N, &T, &Q);

  int i, j;
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      scanf("%d ", &PA[i][j]);
    }
  }

  for (int z = 1; z <= T; z++) {
    compute(z);

/*    printf("PA:\n");
    for (i = 1; i <= N; i++, printf("\n")) {
      for (j = 1; j <= N; j++) {
        printf("%d ", PA[i][j]);
      }
    }
    printf("EFF:\n");
    for (i = 1; i <= N; i++, printf("\n")) {
      for (j = 1; j <= N; j++) {
        printf("%d ", PMAX[i][j]);
      }
    }*/
  }

  int s = 0;
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= N; j++) {
      s = (s + PA[i][j]);
      while (s >= Q) {
        s = s - Q;
      }
    }
  }

  printf("%d ", s);
  return 0;
}
