// Andrei Grigorean - 100 puncte
#include <cassert>
#include <cstdio>

const int MAX_Q = 20000;
const int MAX_MOD = 30000;
const int MAX_COORD = 100000000;

int q, mod;

int bitQuery(int bit, int x, int y) {
  ++x; ++y;
  int dim = 1 << bit;

  int zero = x / (2 * dim) * dim + (x % (2 * dim) >= dim ? dim : x % (2 * dim));
  int one = x - zero;

  int normal = y / (2 * dim) * dim + (y % (2 * dim) >= dim ? dim : y % (2 * dim));
  int reverse = y - normal;

  zero %= mod;
  one %= mod;
  normal %= mod;
  reverse %= mod;
  dim %= mod;

  return dim * (normal * one % mod + reverse * zero % mod) % mod;
}

int query(int x1, int y1, int x2, int y2) {
  int sol = 0;

  for (int bit = 0; bit < 30; ++bit)
    sol = (sol + bitQuery(bit, x2, y2) - bitQuery(bit, x2, y1 - 1) -
          bitQuery(bit, x1 - 1, y2) + bitQuery(bit, x1 - 1, y1 - 1) + 2 * mod) % mod;

  return sol;
}

int main() {
  assert(freopen("xor.in", "r", stdin) != NULL);
  assert(freopen("xor.out", "w", stdout) != NULL);

  assert(scanf("%d %d", &q, &mod) == 2);
  assert(1 <= q && q <= MAX_Q);
  assert(1 <= mod && mod <= MAX_MOD);

  for (int step = 0; step < q; ++step) {
    int x1, x2, y1, y2;

    assert(scanf("%d %d %d %d", &x1, &y1, &x2, &y2) == 4);
    assert(1 <= x1 && x1 <= MAX_COORD);
    assert(1 <= y1 && y1 <= MAX_COORD);
    assert(1 <= x2 && x2 <= MAX_COORD);
    assert(1 <= y2 && y2 <= MAX_COORD);
    assert(x1 <= x2);
    assert(y1 <= y2);

    printf("%d\n", query(x1, y1, x2, y2));
  }
}
