//by Puni Andrei Paul
//Time complexity: O(T * log N)
//Memory complexity: O(1)
//Method: divide et impera
//Work Time: 45 min

#include <cstdio>
#include <cassert>

#include <algorithm>

using namespace std;

#define ll long long

ll P;

inline ll unu(int x,int bit)
{
	++x;
	bit = 1 << bit;
	ll ret;
	ll ori = x / bit;	
	if (ori % 2 == 1)
		ret = (ori/2)*bit + (x % bit);
	else
		ret = (ori/2)*bit;	
	ret %= P;
	return ret;
}

inline ll zero(int y,int bit)
{	
	return (y+1 - unu(y,bit)+P)%P;	
}

int q(int x,int y)
{
	int ret = 0; 
	for (int bit = 0; (1 << bit) <= max(x, y); ++bit)
	{
		ll A = (zero(x, bit) * unu(y, bit))%P;
		ll B = (zero(y, bit) * unu(x, bit))%P;
		A += B;
		A <<= bit;
		A %= P;
		//printf("bit %d => %lld\n", bit, A);
		ret = (ret + A)%P;
	}
	return ret;		
}

int rasp(int x1,int y1,int x2,int y2)
{
	//assert(0 <= x1 && x1 <= x2 && x2 <= 1000000000);	
	//assert(0 <= y1 && y1 <= y2 && y2 <= 1000000000);	
	return (q(x2,y2)+q(x1-1,y1-1)-q(x2,y1-1)-q(x1-1,y2)+2*P)%P;
}

int main()
{
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);
	
	int t, x1,y1,x2,y2;
	
	scanf("%d%lld", &t, &P);
	assert(0 < t && t <= 100000);
	assert(2 <= P && P <= 1000000000);
	
	while (t--)
	{
		scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
		
		printf("%d\n", rasp(x1,y1,x2,y2));	
	}
	
	return 0;	
}
