//by Puni Andrei Paul
//Time complexity: O(T * log N)
//Memory complexity: O(1)
//Method: divide et impera
//Work Time: 45 min

#include <cstdio>
#include <cassert>

using namespace std;

int P;

inline int unu(int x,int bit)
{
	++x;
	bit = 1 << bit;
	int ori = x / bit;	
	int ret = (ori/2)*bit;		
	if (ori % 2 == 1)
		ret += (x % bit);
	return ret;
}

int q_(int x, int y)
{
	int ret = 0;
	for (int i=0;i<=x;++i)
	for (int j=0;j<=y;++j)
	{
		ret += i^j;
		ret %= P;
	}
	printf("!q(%d,%d) = %d\n", x, y, ret);
	return ret;
}


int q(int x,int y)
{
	int ret = 0, z1, z2, u1, u2; 
	for (int bit = 0; bit <= 29; ++bit)
	{
		u1 = unu(x,bit);
		z1 = x+1 - u1;
		u2 = unu(y,bit);
		z2 = y+1 - u2;		
		//printf("X = %d bit = %d unu = %d zero = %d\n", x+1, bit, u1, z1);		
		//printf("Y = %d bit = %d unu = %d zero = %d\n", y+1, bit, u2, z2);		
		ret = (ret + (((u1*z2 + u2*z1)%P)<<bit))%P;
	}
	//printf("q(%d,%d) = %d\n", x,y, ret);
	return ret;		
}

int rasp(int x1,int y1,int x2,int y2)
{
	assert(0 <= x1 && x1 <= x2 && x2 <= 1000000000);	
	assert(0 <= y1 && y1 <= y2 && y2 <= 1000000000);	
	return (q(x2,y2)+q(x1-1,y1-1)-q(x2,y1-1)-q(x1-1,y2)+2*P)%P;
}

int rasp_(int x1,int y1,int x2,int y2)
{
	return (q_(x2,y2)+q_(x1-1,y1-1)-q_(x2,y1-1)-q_(x1-1,y2)+2*P)%P;
}

int main()
{
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);
	
	int t, x1,y1,x2,y2;
	
	scanf("%d%d", &t, &P);
	assert(0 < t && t <= 100000);
	assert(2 <= P && P <= 1000000000);
	
	while (t--)
	{
		scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
		
		printf("%d\n", rasp(x1,y1,x2,y2));	
		//printf("!%d\n", rasp_(x1,y1,x2,y2));	
	}
	
	return 0;	
}
