//by Puni Andrei Paul
//Time complexity: O(T * log N)
//Memory complexity: O(1)
//Method: divide et impera
//Work Time: 45 min

#include <cstdio>
#include <cassert>

using namespace std;

int P;

#define unu(retx,xx,bitx) retx = ((xx >> bitx)/2)<<bitx;   if ((xx >> bitx) & 1)	retx += (xx & ((1<<bitx)-1));
#define ll long long

inline int q(int x,int y)
{
	int ret = 0, u1, u2; 
	++x, ++y;
	for (int bit = 0; bit <= 26; ++bit)
	{
		unu(u1,x,bit);
		unu(u2,y,bit);
		ret = ((ll)((ll)ret + (ll)((((ll)u1*(ll)(y - u2) + (ll)u2*(ll)(x - u1))%P)<<bit))%P);
	}
	return ret;		
}

inline int rasp(int x1,int y1,int x2,int y2)
{
	assert(0 <= x1 && x1 <= x2 && x2 <= 1000000000);	
	assert(0 <= y1 && y1 <= y2 && y2 <= 1000000000);	
	return (q(x2,y2)+q(x1-1,y1-1)-q(x2,y1-1)-q(x1-1,y2)+2*P)%P;
}

int main()
{
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);
	
	int t, x1,y1,x2,y2;
	
	scanf("%d%d", &t, &P);
	assert(0 < t && t <= 100000);
	assert(2 <= P && P <= 1000000000);
	
	while (t--)
	{
		scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
		
		printf("%d\n", rasp(x1,y1,x2,y2));	
		//printf("!%d\n", rasp_(x1,y1,x2,y2));	
	}
	
	return 0;	
}
