//autor: Puni Andrei Paul
//complexitate: O(N + M * log M + M * log N)

#include <fstream>
#include <vector>
#include <algorithm>

#include <iostream>

using namespace std;

#define Nmax 100100

int n,m;

vector <int> l[Nmax];
vector <pair<int, int> > V[Nmax], lista_muchii;

int Plus[Nmax], Minus[Nmax], df_number;
char viz[Nmax];
int X[Nmax], Y[Nmax], Viteza[Nmax], Distanta[Nmax];
double raspuns[Nmax];
int Qx[Nmax], Qy[Nmax], Qv[Nmax], Qind[Nmax];
int t[Nmax][18];
int inaltime[Nmax];
int fst[Nmax];
int lin[2*Nmax];


double aib_distanta[Nmax*2];

void update_distanta(int poz, double cat) {
	for (;poz < Nmax*2; poz += poz&-poz)
		aib_distanta[poz] += cat;
}

double querry_distanta(int poz) {
	double ret = 0;
	for (;poz > 0; poz -= poz&-poz)
		ret += aib_distanta[poz];
	return ret;
}

double aib_limitat[Nmax*2];

void update_limitat(int poz, double cat) {
	for (;poz < Nmax*2; poz += poz&-poz)
		aib_limitat[poz] += cat;
}

double querry_limitat(int poz) {
	double ret = 0;
	for (;poz > 0; poz -= poz&-poz)
		ret += aib_limitat[poz];
	return ret;
}



void sorteaza(int st, int dr) {
	int i = st, j = dr, piv = Qv[(st+dr)/2];
	
	do {
		while (Qv[i] < piv) ++i;
		while (Qv[j] > piv) --j;
		if (i <= j) {
			swap(Qx[i], Qx[j]);
			swap(Qy[i], Qy[j]);
			swap(Qv[i], Qv[j]);
			swap(Qind[i], Qind[j]);
			++i, --j;
		}
	} while (i <= j);
	
	if (st < j)
		sorteaza(st, j);
	if (i < dr)
		sorteaza(i, dr);	
}

void read() {
	ifstream fin("trenuri.in");
	
	fin >> n >> m;
	
	int x,y,v,d;
	
	for (int i = 1; i < n; ++i) {
		fin >> x >> y >> d >> v;
		l[x].push_back(y);
		l[y].push_back(x);
		
		V[x].push_back(make_pair(y, i));
		V[y].push_back(make_pair(x, i));
		
		lista_muchii.push_back(make_pair(v, i));
		
		X[i] = x;
		Y[i] = y;
		Viteza[i] = v;
		Distanta[i] = d;
	}
	
	for (int i = 1; i <= m; ++i) {
		fin >> Qx[i] >> Qy[i] >> Qv[i];	
		Qind[i] = i;	
	}
	
	fin.close();
}

void DF(int nod, int muchie, int tata) {		
	//cout << "am ajuns la nodul " << nod << " din nodul " << tata << " pe muchia " << muchie << "[" << Distanta[muchie] << "]"<< "\n";
	
	viz[nod] = 1;
	inaltime[nod] = inaltime[tata]+1;
	t[nod][0] = tata;
	
	Plus[muchie] = ++df_number;
	
	fst[nod] = df_number;
	lin[df_number] = nod;
	
	vector<int>::iterator it = l[nod].begin();
	vector< pair<int,int> >::iterator it2 = V[nod].begin();
	for (; it != l[nod].end(); ++it, ++it2) {
		if (viz[*it] == 0) {
			DF(*it, it2->second, nod);
		}
	}
	
	Minus[muchie] = ++df_number;	
	lin[df_number] = -nod;
}

void liniarizeaza() {
	DF(1, 0, 0);		
}

void calculeaza_lca() {
	for (int j = 1; (1<<j) <= n; ++j)
	for (int i = 1; i <= n; ++i) {
		t[i][j] = t[t[i][j-1]][j-1];
	}
}

int LCA(int nod1, int nod2) {
	int pas = 1;
		
	if (inaltime[nod1] > inaltime[nod2]) {
		int dif = inaltime[nod1] - inaltime[nod2];
		for (int i = 0; (1<<i) <= dif; ++i)
		if ((1<<i)&dif)
			nod1 = t[nod1][i];
	}
	
	if (inaltime[nod1] < inaltime[nod2]) {
		int dif = inaltime[nod2] - inaltime[nod1];
		for (int i = 0; (1<<i) <= dif; ++i)
		if ((1<<i)&dif)
			nod2 = t[nod2][i];
	}

	if (nod1 == nod2)
		return nod1;
	
	while((1<<pas) <= inaltime[nod1])
		++pas;
		
	while (pas >= 0) {
		if (t[nod1][pas] != t[nod2][pas]) {
			nod1 = t[nod1][pas];
			nod2 = t[nod2][pas];
		}
			else
		--pas;
	}
	
	return t[nod1][0];
}

void init_aib() {
	for (int i = 1; i < n; ++i) {
		update_distanta(Plus[i] , +Distanta[i]);
		update_distanta(Minus[i], -Distanta[i]);
	}
}

void calculeaza_rasp() {

	//ofstream debug("debug.txt");
/*
	for (int i = 1; i <= m; ++i)
		debug << Qv[i] << "\n";


	for (int i = 1; i < n; ++i)
		debug << "Plus[" << i << "]=" << Plus[i] << " " << "Minus[" << i << "]=" << Minus[i] << "\n";
	
	for (int i = 1; i <= df_number; ++i)
		debug << lin[i] << " ";	
	debug << "\n";

	for (int i = 1; i <= df_number; ++i)
		debug << querry_distanta(i)-querry_distanta(i-1) << " ";	
	debug << "\n";
*/	
	
	vector <pair<int, int> >::iterator it_muchii = lista_muchii.begin();
	
	for (int i = 1; i <= m; ++i) {
		//toate pana la Qv[i] trebuie bagate in aib
		while (it_muchii != lista_muchii.end() && it_muchii->first <= Qv[i]) {
			//debug << " ** sterg muchia " << it_muchii->second << " [" << X[it_muchii->second] << ", " << Y[it_muchii->second] << "]" << " - " << Distanta[it_muchii->second] << "\n"; 
			
			update_distanta(Plus[it_muchii->second] , (double)-Distanta[it_muchii->second]);
			update_distanta(Minus[it_muchii->second], (double)+Distanta[it_muchii->second]);			
			
			update_limitat(Plus[it_muchii->second] , (double)+Distanta[it_muchii->second]/(double)Viteza[it_muchii->second]);
			update_limitat(Minus[it_muchii->second], (double)-Distanta[it_muchii->second]/(double)Viteza[it_muchii->second]);			
			++it_muchii;
		}
		//calulez LCA si drumu`
		
		int lca = LCA(Qx[i], Qy[i]);
		
		//debug << "!! querry " << Qx[i] << " " << Qy[i] << " - " << Qv[i] << "\n";
		//debug << "lca = " << lca << "\n";
		
		//drum X la LCA + drum LCA la Y			
		//partea cu viteza Qv[i]
		
		
		double rasp = 0;

		//debug << "pt aia cu viteza maxima ...\n";		
		//debug << "de la x la lca  = " << (querry_distanta(fst[Qx[i]])-querry_distanta(fst[lca]-1))/(double)Qv[i] << "[" << (querry_distanta(fst[Qx[i]])-querry_distanta(fst[lca]-1)) << "]"<< "\n";
		//debug << "de la y la lca  = " << (querry_distanta(fst[Qy[i]])-querry_distanta(fst[lca]-1))/(double)Qv[i] << "[" << (querry_distanta(fst[Qy[i]])-querry_distanta(fst[lca]-1)) << "]"<< "\n";
		
		if (Qx[i] != lca)
			rasp += (double)(querry_distanta(fst[Qx[i]])-querry_distanta(fst[lca]))/(double)Qv[i];
			
		if (Qy[i] != lca)
			rasp += (double)(querry_distanta(fst[Qy[i]])-querry_distanta(fst[lca]))/(double)Qv[i];
		
			
		//partea cu viteza maxima pe muchii

		//debug << "pt aia cu viteza maxima pe muchii ...\n";		
		//debug << "de la x la lca  = " << (querry_limitat(fst[Qx[i]])-querry_limitat(fst[lca]-1)) << "\n";
		//debug << "de la y la lca  = " << (querry_limitat(fst[Qy[i]])-querry_limitat(fst[lca]-1)) << "\n";
		
		if (Qx[i] != lca)
			rasp += (double)(querry_limitat(fst[Qx[i]])-querry_limitat(fst[lca]));
		if (Qy[i] != lca)			
			rasp += (double)(querry_limitat(fst[Qy[i]])-querry_limitat(fst[lca]));
		
		//setez raspunsul			
		
		raspuns[i] = rasp;
	}
	
	//debug.close();
}

void test_lca() {
	ofstream debug("test_lca.txt");
	for (int i = 1; i <= n; ++i)
	for (int j = 1; j <= n; ++j)
		debug << "lca[" << i << "," << j << "] = " << LCA(i, j) << "\n";
	debug.close();	
}

void sort_rasp(int st, int dr) {
	int i = st, j = dr, piv = Qind[(st+dr)/2];
	
	do {
		while (Qind[i] < piv) ++i;
		while (Qind[j] > piv) --j;
		if (i <= j) {			
			swap(Qind[i], Qind[j]);
			swap(raspuns[i], raspuns[j]);
			++i, --j;
		}
	} while (i <= j);
	
	if (st < j)
		sort_rasp(st, j);
	if (i < dr)
		sort_rasp(i, dr);		
}

void solve() {
	//sortez querry-urile
	sorteaza(1, m);
	
	sort(lista_muchii.begin(), lista_muchii.end());
	
	liniarizeaza();
	
	calculeaza_lca();
	
	//test_lca();
		
	init_aib();
	
	calculeaza_rasp();
	
	//sortez raspunsurile in raport cu ordinul lor	
	
	sort_rasp(1, m);
}

void write() {
	FILE *fout = fopen("trenuri.out", "w");
	for (int i = 1; i <= m;++i)
		fprintf(fout, "%.3f\n", raspuns[i]);
	
	fclose(fout);
}

int main() {
	read();
	solve();	
	write();
	
	return 0;
}
