/*
 * Author: Cosmin Gheorghe
 * Time complexity: O(N^3 * big_numbers)
 */

#include <stdio.h>
#include <algorithm>
using namespace std;

#define NMAX 310
#define CMAX 1010
#define BASE 10000
#define NRC 4

int N, M;

char s[CMAX];

int poz[CMAX];

char used[NMAX];
int sol[NMAX];

int a[CMAX], b[CMAX];

void inm(int a[], int x)
{
	int i, t = 0;

	for (i = 1; i <= a[0] || t; i++, t /= BASE)
		a[i] = (t += a[i] * x) % BASE;

	a[0] = i - 1;
}

void scad(int a[], int b[])
{
	int i;

	for (i = 1; i <= a[0] || i <= b[0]; i++) {
		a[i] -= b[i];
		if (a[i] < 0) a[i] += BASE, a[i + 1]--;
	}

	while (a[0] && !a[a[0]]) a[0]--;
}

int mai_mic(int a[], int b[])
{
	if (a[0] < b[0]) return 1;
	if (a[0] > b[0]) return 0;

	for (int i = a[0]; i >= 1; i--) {
		if (a[i] < b[i]) return 1;
		if (a[i] > b[i]) return 0;
	}

	return 0;
}

void numara(int a[], int sol[], char used[], int last, int M)
{
	int i, nr = last;

	for (i = 0; i < CMAX; i++) a[i] = 0;
	a[0] = 1; a[1] = 1;

	for (i = 1; i <= N; i++) {
		if (i <= last) {
			if (i - sol[i] + 1 > M) {
				for (i = 0; i < CMAX; i++) a[i] = 0;
				return;
			}
		}

		if (used[i]) continue;
	
		// pun i
		// i poate fi pus pana i + M - 1

		inm(a, min(N - nr, i + M - 1 - nr));

		nr++;
	}

	while (a[0] && !a[a[0]]) a[0]--;
}

int main()
{
	int i, j;

	freopen("bubblesort.in", "r", stdin);
	freopen("bubblesort.out", "w", stdout);

	scanf("%d %d %s", &N, &M, s);

	int n = strlen(s);

	for (i = n - 1; i >= 0; i -= NRC) {
		int q = 0;
		for (j = max(0, i - NRC + 1); j <= i; j++)
			q = q * 10 + s[j] - '0';
	
		poz[++poz[0]] = q;
	}

	// si acum reconstituirea
	
	for (i = 1; i <= N; i++) {
		// vad ce pot sa pun pe pozitia i

		for (j = 1; j <= N; j++) {
			if (used[j]) continue;

			sol[i] = j;
			used[j] = 1;

			numara(a, sol, used, i, M);
			numara(b, sol, used, i, M - 1);

			scad(a, b);

			if (mai_mic(a, poz)) {
				scad(poz, a);
				used[j] = 0;
			} else break;
		}
	}

	for (i = 1; i <= N; i++) printf("%d ", sol[i]);

	return 0;
}

