/*
 * Author: Cosmin Gheorghe
 * Time complexity: O(N log N)
 */

#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100010

const double pi = acos(-1);

int N;

int xx[NMAX], yy[NMAX];
double uu[NMAX];

double mod_2pi(double x)
{
	while (x >= 2 * pi) x -= 2 * pi;

	return x;
}

int main()
{
	int i;

	freopen("hawaii.in", "r", stdin);
	freopen("hawaii.out", "w", stdout);

	scanf("%d", &N); N++;

	for (i = 1; i <= N; i++) {
		scanf("%d %d", &xx[i], &yy[i]);

		double u = -1;

		u = atan2(yy[i] - yy[1], xx[i] - xx[1]);
		if (u < 0) u += 2 * pi;

		uu[i] = u;
	}

	sort(uu + 2, uu + N + 1);

	for (i = N + 1; i < N + N; i++) uu[i] = uu[i - N + 1] + 2 * pi;

//	for (i = 1; i < N + N; i++) printf("%g ", uu[i] * 180 / pi);
//	printf("\n");
	
	int st, dr = 3;

	long long rez = 0;

	for (st = 2; st <= N; st++) {
		while (uu[dr] < uu[st] + pi) {
			dr++;
//			printf("%d %d\n", st, dr);
//			printf("%g %g\n-----\n", uu[st] + pi, uu[dr]);

			if (dr == N + N) return 0;
		}

//		printf("%d (%g) %d (%g)\n", st, uu[st] + pi, dr, uu[dr]);

		int nr;
		if (st < dr) nr = dr - st - 1;
		else nr = N - st + dr - 2;

//		printf("%d\n", nr);

		rez += (long long) nr * (nr - 1) / 2;
	}
	
	long long c3 = (long long) (N-1) * (N-2) * (N-3) / 6;

//	printf("%lld %lld\n", c3, rez);

	printf("%lld\n", c3 - rez);

	return 0;
}

