/* Autor: Paul-Dan Baltescu */

#include <fstream>
#include <tr1/unordered_map>
#include <vector>

using namespace std;
using namespace tr1;

const int MAXN = 1000010;
const int MOD = 71582857;
const int BAZA = 29;
const int MAXL = 2510;

int N, M, L, K;
char A[MAXN];
char B[MAXL];
unordered_map <int, vector <int> > H;

void buildHash(int l) {
	int b = 1, x = 0;

	for (int i = 1; i <= l; ++i) {
		x = (x * BAZA + A[i]) % MOD;
		if (i < l)
			b = (b * BAZA) % MOD; 
	}

	H[x].push_back(1);

	for (int i = l+1; i <= N; ++i) {
		x = (x - A[i-l] * b) % MOD;
		if (x < 0) 
			x += MOD;
		x = (x * BAZA + A[i]) % MOD;
		H[x].push_back(i-l);
	}
}

int check(int start) {
	if (start < 0 || start + L > N)
		return 0;

	int cnt = 0;

	for (int i = 1; i <= L; ++i) 
		if (A[start+i] != B[i]) {
			++cnt;
			if (cnt > K)
				return 0;
		}
	
	return 1;
}

int main() {
	ifstream fin("radio.in");
	ofstream fout("radio.out");

	fin >> N >> M >> L >> K;

	fin >> (A+1);

	for (int i = 1; i <= N; ++i)
		A[i] -= 'a';

	int l = L / (K+1);

	buildHash(l);

	for (int t = 1; t <= M; ++t) {
		fin >> (B+1);

		for (int j = 1; j <= L; ++j) 
			B[j] -= 'a';

		int res = 0;

		for (int i = 0; i <= K && !res; ++i) {
			int x = 0;

			for (int j = 1; j <= l; ++j)
				x = (x * BAZA + B[i*l+j]) % MOD;

			if (H.find(x) != H.end()) {
				for (size_t j = 0; j < H[x].size() && !res; ++j)
					res |= check(H[x][j] - i*l);
			}
		}

		fout << res << '\n';
	}

	return 0;
}
