//autor: Puni Andrei-Paul
//complexitate: O(N^3/2 log N)

#include <stdio.h>

#define Nmax 200100
#define DivMax 512
#define CicluMax 512

int n;
int sir[Nmax];
int perm[Nmax];
int retPerm[Nmax];

char viz[Nmax];


int cmmmc[Nmax];
int fctPrim[DivMax];
int nrFact = 0; 

int ciclu[Nmax];

int nrLungimi;
int lungimiCicluri[CicluMax];
int restPtMutari[Nmax];
int restLaCmmmc[Nmax]; //inca nu am folosit
char existaLng[Nmax];
char bagatInCmmmc[Nmax];

long long putMod(int nr, int put, int mod) {
	if (put == 0)
		return 1;
	if (put == 1)
		return nr%mod;
	long long tmp = putMod(nr, put/2, mod);
	tmp = (long long)tmp*tmp%mod;
	tmp = (long long)tmp*putMod(nr, put&1, mod)%mod;
	return tmp;
}

int restCmmmcLaLng(int lngCiclu) {
	int restCmmmc = 1;
	int j;
	for (j = 0; j < nrFact; ++j) {
		restCmmmc = (long long)restCmmmc * putMod(fctPrim[j], cmmmc[fctPrim[j]], lngCiclu) % lngCiclu; 
	}
	return restCmmmc;
}

int main() {
	freopen("randomizare.in" , "r", stdin );
	freopen("randomizare.out", "w", stdout);
	
	scanf("%d", &n);
	
	int i, j;
	
	for (i = 1; i <= n; ++i) {
		scanf("%d", &sir[i]);
	}

	for (i = 1; i <= n; ++i) {
		scanf("%d", &perm[i]);
	}
	
	int nrCicluri = 0;
	
	for (i = 1; i <= n; ++i) {
		if (viz[i] != 0)
			continue;
		++nrCicluri;
		int poz = i;
		int lngCiclu = 0;
		while (viz[poz] == 0) {
			++lngCiclu;
			viz[poz] = 1;
			poz = perm[poz];
		}
		if (existaLng[lngCiclu] != 0) 
			continue;
		
		existaLng[lngCiclu] = 1;
		lungimiCicluri[++nrLungimi] = lngCiclu;		
	}
	
	for (i = 1; i <= n; ++i) 
		viz[i] = 0;
		
	for (i = 1; i <= n; ++i) {
		if (viz[i] != 0)
			continue;

		int lngCiclu = 0;
		int poz = i;

		//calculez lungimea ciclului
		while (viz[poz] == 0) {
			ciclu[lngCiclu] = poz;
			++lngCiclu;
			viz[poz] = 1;
			poz = perm[poz];
		}		
		
		//restu e in restPtMutari[lngCiclu]
		
		int minCiclu = restPtMutari[lngCiclu];
		int nrCmmmcMin = 0;
		int nrCmmmc = 0;
		
		//calculez restul la cmmmc
		if (bagatInCmmmc[lngCiclu] == 0) {
		  restLaCmmmc[lngCiclu] = restCmmmcLaLng(lngCiclu);			
					
			//merg din cmmmc in cmmmc mutari si caut minumul
			
			poz = restPtMutari[lngCiclu];
			
			while (viz[ciclu[poz]] != 2) {
				if (sir[ciclu[minCiclu]] > sir[ciclu[poz]]) {
					minCiclu = poz;
					nrCmmmcMin = nrCmmmc;
				}
				
				viz[ciclu[poz]] = 2;
				poz = (poz + restLaCmmmc[lngCiclu]) % lngCiclu;
				++nrCmmmc;
			}		
		
			//fac update la resturi daca s-a modificat cmmmc
			
			for (j = 1; j <= nrLungimi; ++j) {			
				restPtMutari[lungimiCicluri[j]] = 
					(long long)((long long)restPtMutari[lungimiCicluri[j]] + 
					(long long)nrCmmmcMin*restCmmmcLaLng(lungimiCicluri[j])) 
					% (long long)lungimiCicluri[j]; 
			}
		}
		
		//bag la rezultat ciclu curent
		
		for (j = 0; j < lngCiclu; ++j) {
			retPerm[ciclu[j]] = ciclu[(j+minCiclu)%lngCiclu];
		}		


		if (bagatInCmmmc[lngCiclu] != 0) 
			continue;
		
		bagatInCmmmc[lngCiclu] = 1;
		//fac update la cmmmc		
		
		for (j = 2; j*j <= lngCiclu; ++j) {
			if (lngCiclu % j != 0) 
				continue;
			int put = 0;
			while (lngCiclu % j == 0) {
				++put;
				lngCiclu /= j;
			}
			if (cmmmc[j] < put) {
				if (cmmmc[j] == 0) {
					fctPrim[nrFact] = j;					
					++nrFact;
				}
				cmmmc[j] = put;
			}
		}				

		if (lngCiclu > 1) {
			j = lngCiclu;
			if (cmmmc[j] < 1) {
				if (cmmmc[j] == 0) {
					fctPrim[nrFact] = j;					
					++nrFact;
				}
				cmmmc[j] = 1;
			}
		}	
	}
	
	for (i = 1; i <= n; ++i) {
		printf("%d ", sir[retPerm[i]]);	
	}
		
	//fprintf(stderr, "%d cicluri %d factori\n", nrCicluri, nrFact);
	
	return 0;
}
