/* Gheorghe Cosmin
 * Solutie O(N * K) timp si O(N * K) memorie
 */

#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100010
#define KMAX 110

int N, K;

vector <int> leg[NMAX], fiu[NMAX];

int din[NMAX][KMAX]; // numarul minim de muchii ce trebuiesc taiate pentru a rezolva subarborele i, iar distanta maxima intre i si o frunza este <= j

int viz[NMAX];

int val[NMAX];

int sfp = 0, fm = 0, jeg;

void back(int x)
{
	vector <int> :: iterator it;
	int k, y;

	viz[x] = 1;

	for (it = leg[x].begin(); it != leg[x].end(); ++it) {
		if (viz[*it]) continue;

		back(*it);

		fiu[x].push_back(*it);
	}

/*	// ---- de sters -------------------------
	int w = fiu[x].size();
	if (w > fm) fm = w;
	sfp += w * w;
	//---------------------------------------
*/
	if ((int) fiu[x].size() == 0) {
		for (k = 0; k <= K; k++) din[x][k] = 0;

		return;
	}

	// am mai mult de 1 fiu
	
	// setez distanta maxima intre x si o frunza din subarbore ca fiind <= k
	
	// mai intai fac pentru distanta maxima <= 0
	
	for (it = fiu[x].begin(); it != fiu[x].end(); ++it) {
		din[x][0] += 1 + din[*it][K]; // tai muchia i->fiu si pentru fi aleg best (adica din[fiu][K])
	}

//	printf("caz 0: %d %d\n", x, din[x][0]);

	// pentru distanta > 0
	
	for (k = 1; k <= K; k++) {
		din[x][k] = din[x][k - 1];

		// distanta fiecarui nod trebuie sa fie <= k-1 && <= K - k - 1
		// gasesc cea mai buna valoare pentru distanta aia
	
		int s = 0;
		for (it = fiu[x].begin(); it != fiu[x].end(); ++it) {
			y = *it;
			val[y] = 1 + din[y][K]; // sa zicem ca tai muchia pana la el
			int q = min(k - 1, K - k - 1);
			if (q >= 0) val[y] = min(val[y], din[y][q]); // pastrez muchia si aleg sa fie <= cat de mult poate (functie crescatoare)
			s += val[y];

//			for (int i = 1; i <= fiu[x].size(); i++) {
//				for (int kk = 1; kk <= K; kk++)
//					jeg += *it;
//			}
		}

		// setez pe cine pun la distanta <= k
		for (it = fiu[x].begin(); it != fiu[x].end(); ++it) {
			y = *it;
			din[x][k] = min(din[x][k], s - val[y] + din[y][k - 1]);
		}
//		printf("%d %d -> %d | s = %d\n", x, k, din[x][k], s);
	}
}

int main()
{
	int i, x, y;

	freopen("kdtree.in", "r", stdin);
	freopen("kdtree.out", "w", stdout);

	scanf("%d %d", &N, &K);

	for (i = 1; i < N; i++) {
		scanf("%d %d", &x, &y);

		leg[x].push_back(y);
		leg[y].push_back(x);
	}

	back(1);

	printf("%d\n", din[1][K]);

	return 0;
}

