/* Gheorghe Cosmin
 * Solutie O(2^N * N^3)
 */

#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>
using namespace std;

#define NMAX 25
#define INF 1000

int N, K;

int dist[NMAX][NMAX];
char nrb[1 << NMAX];

int xx[NMAX], yy[NMAX];

int main()
{
	int i, j, k, st, rez;

	freopen("kdtree.in", "r", stdin);
	freopen("kdtree.out", "w", stdout);

	scanf("%d %d", &N, &K);

	for (i = 1; i < N; i++) {
		scanf("%d %d", &xx[i], &yy[i]);
	}

	rez = INF;

	for (st = 0; st < (1 << (N - 1)); st++) {
		nrb[st] = nrb[st >> 1] + (st & 1);

//		memset(dist, 0, sizeof(dist));

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++) 
				if (i != j) dist[i][j] = INF;

		for (i = 1, j = 1; j < N; i <<= 1, j++)
			if (!(i & st)) dist[ xx[j] ][ yy[j] ] = dist[ yy[j] ][ xx[j] ] = 1;

		for (k = 1; k <= N; k++)
			for (i = 1; i <= N; i++)
				for (j = 1; j <= N; j++)
					if (dist[i][k] + dist[k][j] < dist[i][j])
						dist[i][j] = dist[i][k] + dist[k][j];

		int e = 1;
		for (i = 1; i <= N; i++) {
			for (j = 1; j <= N; j++) {
				if (dist[i][j] != INF && dist[i][j] > K) e = 0;
//				printf("%d ", dist[i][j]);
			}
//			printf("\n");
		}

		if (e) rez = min(rez, (int) nrb[st]);
	}

	printf("%d\n", rez);

	return 0;
}

