// O(M * N)

#include <stdio.h>
#include <stdlib.h>

#define NMAX 2050

int d[NMAX][NMAX], bmax[NMAX][NMAX], Tlast[NMAX], pozlast[NMAX];
int i, j, k, N, M, T, C, B, b, t;

int main()
{
	freopen("bcrc.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
		{
			d[i][j] = abs(i - j);

			if (N - d[i][j] < d[i][j])
				d[i][j] = N - d[i][j];
		}

	for (i = 0; i < N; i++)
	{
		Tlast[i] = pozlast[i] = 0;
		for (j = 0; j < NMAX; j++)
			bmax[i][j] = -1;
	}

	bmax[0][0] = 0;

	for (k = 0; k < M; k++)
	{
		scanf("%d %d %d", &T, &C, &B);
		C--;

		b = -1;
		for (i = 0; i < N; i++)
		{
			// query for room #i -> O(1) per query

			t = T - Tlast[i];
			t -= d[C][i];

			if (t > 0)
				t = 0;

			if (bmax[i][(pozlast[i] + t + NMAX) % NMAX] > b)
				b = bmax[i][(pozlast[i] + t + NMAX) % NMAX];
		}

		if (b >= 0)
		{
			b += B;

			// update for room #C -> O(N) per update

			if (T - Tlast[C] < NMAX)
			{
				for (i = (pozlast[C] + 1) % NMAX; i != pozlast[C]; i = (i + 1) % NMAX)
				{
					Tlast[C]++;
					bmax[C][i] = bmax[C][(i - 1 + NMAX) % NMAX];
				
					if (T == Tlast[C])
					{
						pozlast[C] = i;
						break;
					}
				}
			}
			else
			{
				B = bmax[C][pozlast[C]];

				for (i = 0; i < NMAX; i++)
					bmax[C][i] = B;

				pozlast[C] = NMAX - 1;
			}

			Tlast[C] = T;
			bmax[C][pozlast[C]] = b;
		}
	}

	freopen("bcrc.out", "w", stdout);
	b = 0;

	for (i = 0; i < N; i++)
		if (bmax[i][pozlast[i]] > b)
			b = bmax[i][pozlast[i]];

	printf("%d\n", b);

	return 0;
}
