#include <stdio.h>
#include <algorithm>

using namespace std;

#define MAX_N 20005
#define FIN "campion.in"
#define FOUT "campion.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define EPS 1e-7
#define x first.first
#define y first.second
#define cnt second
#define mp make_pair

typedef pair<pair<double, double>, int> entry;

int N, T, stk[MAX_N], stk_len, Res; entry E[MAX_N];
char U[MAX_N];

inline int sgn(entry a, entry b, entry c)
{
    double t = (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
    return t < 0.0 ? -1 : t > 0.0 ? +1 : 0;
}

int main(void)
{
    int i, j, inc;
    double max = 0.0;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d", &N, &T);
    FOR (i, 0, N)
    {
        scanf("%lf %lf", &E[i].x, &E[i].y); E[i].cnt = 1;
        if (max < E[i].x) max = E[i].x;
    }

    // remove duplicates and obvious losers
    sort(E, E+N);
    reverse(E, E+N);
    FOR (i, 1, N) Res += E[0].x == E[i].x && E[0].y != E[i].y;
    for (i = j = 1; i < N; i++)
        if (E[j-1] == E[i]) 
            E[j-1].cnt++;
        else
        if (E[j-1].y < E[i].y)
            E[j++] = E[i];
    N = j;

    if (N == 1) { printf("%d\n", Res+E[0].cnt); return 0; }

    // dualize
    FOR (i, 0, N)
    {
        E[i].x -= max+1;
        E[i].first = mp(E[i].y / E[i].x, -1.0 / E[i].x);
    }
    E[N++] = mp(mp(1.0 / EPS, 0.0), 0); // vertical line at -EPS
    E[N++] = mp(mp(-1.0 / (double) T, 0.0), 0); // vertical line at T

    // convex hull
    sort(E, E+N);
    stk[0] = 0; U[stk[1] = 1] = 1; stk_len = 2;
    for (inc = 1, i = 2; i >= 0; i += inc)
    {
        if (U[i]) continue;
        while (stk_len > 1 && sgn(E[stk[stk_len-2]], E[stk[stk_len-1]], E[i]) > 0)
              U[stk[--stk_len]] = 0;
        U[stk[stk_len++] = i] = 1;
        if (i == N-1) inc *= -1;
    }

    FOR (i, 0, stk_len-1) Res += E[stk[i]].cnt;
    printf("%d\n", Res);
    
    return 0;
}
